(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.unexpected = global.unexpected || {}, global.unexpected.dom = {})));
}(this, (function (exports) {
	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	function getCjsExportFromNamespace (n) {
		return n && n['default'] || n;
	}

	var matchesSelector = function (elm, selector) {
	  var matchFuntion =
	    elm.matchesSelector ||
	    elm.mozMatchesSelector ||
	    elm.msMatchesSelector ||
	    elm.oMatchesSelector ||
	    elm.webkitMatchesSelector ||
	    function (selector) {
	      var node = this;
	      var nodes = (node.parentNode || node.document).querySelectorAll(
	        selector
	      );
	      var i = 0;

	      while (nodes[i] && nodes[i] !== node) {
	        i += 1;
	      }

	      return !!nodes[i];
	    };

	  return matchFuntion.call(elm, selector);
	};

	var prism = createCommonjsModule(function (module) {
	/* **********************************************
	     Begin prism-core.js
	********************************************** */

	/// <reference lib="WebWorker"/>

	var _self = (typeof window !== 'undefined')
		? window   // if in browser
		: (
			(typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope)
			? self // if in worker
			: {}   // if in node js
		);

	/**
	 * Prism: Lightweight, robust, elegant syntax highlighting
	 *
	 * @license MIT <https://opensource.org/licenses/MIT>
	 * @author Lea Verou <https://lea.verou.me>
	 * @namespace
	 * @public
	 */
	var Prism = (function (_self){

	// Private helper vars
	var lang = /\blang(?:uage)?-([\w-]+)\b/i;
	var uniqueId = 0;


	var _ = {
		/**
		 * By default, Prism will attempt to highlight all code elements (by calling {@link Prism.highlightAll}) on the
		 * current page after the page finished loading. This might be a problem if e.g. you wanted to asynchronously load
		 * additional languages or plugins yourself.
		 *
		 * By setting this value to `true`, Prism will not automatically highlight all code elements on the page.
		 *
		 * You obviously have to change this value before the automatic highlighting started. To do this, you can add an
		 * empty Prism object into the global scope before loading the Prism script like this:
		 *
		 * ```js
		 * window.Prism = window.Prism || {};
		 * Prism.manual = true;
		 * // add a new <script> to load Prism's script
		 * ```
		 *
		 * @default false
		 * @type {boolean}
		 * @memberof Prism
		 * @public
		 */
		manual: _self.Prism && _self.Prism.manual,
		disableWorkerMessageHandler: _self.Prism && _self.Prism.disableWorkerMessageHandler,

		/**
		 * A namespace for utility methods.
		 *
		 * All function in this namespace that are not explicitly marked as _public_ are for __internal use only__ and may
		 * change or disappear at any time.
		 *
		 * @namespace
		 * @memberof Prism
		 */
		util: {
			encode: function encode(tokens) {
				if (tokens instanceof Token) {
					return new Token(tokens.type, encode(tokens.content), tokens.alias);
				} else if (Array.isArray(tokens)) {
					return tokens.map(encode);
				} else {
					return tokens.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/\u00a0/g, ' ');
				}
			},

			/**
			 * Returns the name of the type of the given value.
			 *
			 * @param {any} o
			 * @returns {string}
			 * @example
			 * type(null)      === 'Null'
			 * type(undefined) === 'Undefined'
			 * type(123)       === 'Number'
			 * type('foo')     === 'String'
			 * type(true)      === 'Boolean'
			 * type([1, 2])    === 'Array'
			 * type({})        === 'Object'
			 * type(String)    === 'Function'
			 * type(/abc+/)    === 'RegExp'
			 */
			type: function (o) {
				return Object.prototype.toString.call(o).slice(8, -1);
			},

			/**
			 * Returns a unique number for the given object. Later calls will still return the same number.
			 *
			 * @param {Object} obj
			 * @returns {number}
			 */
			objId: function (obj) {
				if (!obj['__id']) {
					Object.defineProperty(obj, '__id', { value: ++uniqueId });
				}
				return obj['__id'];
			},

			/**
			 * Creates a deep clone of the given object.
			 *
			 * The main intended use of this function is to clone language definitions.
			 *
			 * @param {T} o
			 * @param {Record<number, any>} [visited]
			 * @returns {T}
			 * @template T
			 */
			clone: function deepClone(o, visited) {
				visited = visited || {};

				var clone, id;
				switch (_.util.type(o)) {
					case 'Object':
						id = _.util.objId(o);
						if (visited[id]) {
							return visited[id];
						}
						clone = /** @type {Record<string, any>} */ ({});
						visited[id] = clone;

						for (var key in o) {
							if (o.hasOwnProperty(key)) {
								clone[key] = deepClone(o[key], visited);
							}
						}

						return /** @type {any} */ (clone);

					case 'Array':
						id = _.util.objId(o);
						if (visited[id]) {
							return visited[id];
						}
						clone = [];
						visited[id] = clone;

						(/** @type {Array} */(/** @type {any} */(o))).forEach(function (v, i) {
							clone[i] = deepClone(v, visited);
						});

						return /** @type {any} */ (clone);

					default:
						return o;
				}
			},

			/**
			 * Returns the Prism language of the given element set by a `language-xxxx` or `lang-xxxx` class.
			 *
			 * If no language is set for the element or the element is `null` or `undefined`, `none` will be returned.
			 *
			 * @param {Element} element
			 * @returns {string}
			 */
			getLanguage: function (element) {
				while (element && !lang.test(element.className)) {
					element = element.parentElement;
				}
				if (element) {
					return (element.className.match(lang) || [, 'none'])[1].toLowerCase();
				}
				return 'none';
			},

			/**
			 * Returns the script element that is currently executing.
			 *
			 * This does __not__ work for line script element.
			 *
			 * @returns {HTMLScriptElement | null}
			 */
			currentScript: function () {
				if (typeof document === 'undefined') {
					return null;
				}
				if ('currentScript' in document && 1 < 2 /* hack to trip TS' flow analysis */) {
					return /** @type {any} */ (document.currentScript);
				}

				// IE11 workaround
				// we'll get the src of the current script by parsing IE11's error stack trace
				// this will not work for inline scripts

				try {
					throw new Error();
				} catch (err) {
					// Get file src url from stack. Specifically works with the format of stack traces in IE.
					// A stack will look like this:
					//
					// Error
					//    at _.util.currentScript (http://localhost/components/prism-core.js:119:5)
					//    at Global code (http://localhost/components/prism-core.js:606:1)

					var src = (/at [^(\r\n]*\((.*):.+:.+\)$/i.exec(err.stack) || [])[1];
					if (src) {
						var scripts = document.getElementsByTagName('script');
						for (var i in scripts) {
							if (scripts[i].src == src) {
								return scripts[i];
							}
						}
					}
					return null;
				}
			},

			/**
			 * Returns whether a given class is active for `element`.
			 *
			 * The class can be activated if `element` or one of its ancestors has the given class and it can be deactivated
			 * if `element` or one of its ancestors has the negated version of the given class. The _negated version_ of the
			 * given class is just the given class with a `no-` prefix.
			 *
			 * Whether the class is active is determined by the closest ancestor of `element` (where `element` itself is
			 * closest ancestor) that has the given class or the negated version of it. If neither `element` nor any of its
			 * ancestors have the given class or the negated version of it, then the default activation will be returned.
			 *
			 * In the paradoxical situation where the closest ancestor contains __both__ the given class and the negated
			 * version of it, the class is considered active.
			 *
			 * @param {Element} element
			 * @param {string} className
			 * @param {boolean} [defaultActivation=false]
			 * @returns {boolean}
			 */
			isActive: function (element, className, defaultActivation) {
				var no = 'no-' + className;

				while (element) {
					var classList = element.classList;
					if (classList.contains(className)) {
						return true;
					}
					if (classList.contains(no)) {
						return false;
					}
					element = element.parentElement;
				}
				return !!defaultActivation;
			}
		},

		/**
		 * This namespace contains all currently loaded languages and the some helper functions to create and modify languages.
		 *
		 * @namespace
		 * @memberof Prism
		 * @public
		 */
		languages: {
			/**
			 * Creates a deep copy of the language with the given id and appends the given tokens.
			 *
			 * If a token in `redef` also appears in the copied language, then the existing token in the copied language
			 * will be overwritten at its original position.
			 *
			 * ## Best practices
			 *
			 * Since the position of overwriting tokens (token in `redef` that overwrite tokens in the copied language)
			 * doesn't matter, they can technically be in any order. However, this can be confusing to others that trying to
			 * understand the language definition because, normally, the order of tokens matters in Prism grammars.
			 *
			 * Therefore, it is encouraged to order overwriting tokens according to the positions of the overwritten tokens.
			 * Furthermore, all non-overwriting tokens should be placed after the overwriting ones.
			 *
			 * @param {string} id The id of the language to extend. This has to be a key in `Prism.languages`.
			 * @param {Grammar} redef The new tokens to append.
			 * @returns {Grammar} The new language created.
			 * @public
			 * @example
			 * Prism.languages['css-with-colors'] = Prism.languages.extend('css', {
			 *     // Prism.languages.css already has a 'comment' token, so this token will overwrite CSS' 'comment' token
			 *     // at its original position
			 *     'comment': { ... },
			 *     // CSS doesn't have a 'color' token, so this token will be appended
			 *     'color': /\b(?:red|green|blue)\b/
			 * });
			 */
			extend: function (id, redef) {
				var lang = _.util.clone(_.languages[id]);

				for (var key in redef) {
					lang[key] = redef[key];
				}

				return lang;
			},

			/**
			 * Inserts tokens _before_ another token in a language definition or any other grammar.
			 *
			 * ## Usage
			 *
			 * This helper method makes it easy to modify existing languages. For example, the CSS language definition
			 * not only defines CSS highlighting for CSS documents, but also needs to define highlighting for CSS embedded
			 * in HTML through `<style>` elements. To do this, it needs to modify `Prism.languages.markup` and add the
			 * appropriate tokens. However, `Prism.languages.markup` is a regular JavaScript object literal, so if you do
			 * this:
			 *
			 * ```js
			 * Prism.languages.markup.style = {
			 *     // token
			 * };
			 * ```
			 *
			 * then the `style` token will be added (and processed) at the end. `insertBefore` allows you to insert tokens
			 * before existing tokens. For the CSS example above, you would use it like this:
			 *
			 * ```js
			 * Prism.languages.insertBefore('markup', 'cdata', {
			 *     'style': {
			 *         // token
			 *     }
			 * });
			 * ```
			 *
			 * ## Special cases
			 *
			 * If the grammars of `inside` and `insert` have tokens with the same name, the tokens in `inside`'s grammar
			 * will be ignored.
			 *
			 * This behavior can be used to insert tokens after `before`:
			 *
			 * ```js
			 * Prism.languages.insertBefore('markup', 'comment', {
			 *     'comment': Prism.languages.markup.comment,
			 *     // tokens after 'comment'
			 * });
			 * ```
			 *
			 * ## Limitations
			 *
			 * The main problem `insertBefore` has to solve is iteration order. Since ES2015, the iteration order for object
			 * properties is guaranteed to be the insertion order (except for integer keys) but some browsers behave
			 * differently when keys are deleted and re-inserted. So `insertBefore` can't be implemented by temporarily
			 * deleting properties which is necessary to insert at arbitrary positions.
			 *
			 * To solve this problem, `insertBefore` doesn't actually insert the given tokens into the target object.
			 * Instead, it will create a new object and replace all references to the target object with the new one. This
			 * can be done without temporarily deleting properties, so the iteration order is well-defined.
			 *
			 * However, only references that can be reached from `Prism.languages` or `insert` will be replaced. I.e. if
			 * you hold the target object in a variable, then the value of the variable will not change.
			 *
			 * ```js
			 * var oldMarkup = Prism.languages.markup;
			 * var newMarkup = Prism.languages.insertBefore('markup', 'comment', { ... });
			 *
			 * assert(oldMarkup !== Prism.languages.markup);
			 * assert(newMarkup === Prism.languages.markup);
			 * ```
			 *
			 * @param {string} inside The property of `root` (e.g. a language id in `Prism.languages`) that contains the
			 * object to be modified.
			 * @param {string} before The key to insert before.
			 * @param {Grammar} insert An object containing the key-value pairs to be inserted.
			 * @param {Object<string, any>} [root] The object containing `inside`, i.e. the object that contains the
			 * object to be modified.
			 *
			 * Defaults to `Prism.languages`.
			 * @returns {Grammar} The new grammar object.
			 * @public
			 */
			insertBefore: function (inside, before, insert, root) {
				root = root || /** @type {any} */ (_.languages);
				var grammar = root[inside];
				/** @type {Grammar} */
				var ret = {};

				for (var token in grammar) {
					if (grammar.hasOwnProperty(token)) {

						if (token == before) {
							for (var newToken in insert) {
								if (insert.hasOwnProperty(newToken)) {
									ret[newToken] = insert[newToken];
								}
							}
						}

						// Do not insert token which also occur in insert. See #1525
						if (!insert.hasOwnProperty(token)) {
							ret[token] = grammar[token];
						}
					}
				}

				var old = root[inside];
				root[inside] = ret;

				// Update references in other language definitions
				_.languages.DFS(_.languages, function(key, value) {
					if (value === old && key != inside) {
						this[key] = ret;
					}
				});

				return ret;
			},

			// Traverse a language definition with Depth First Search
			DFS: function DFS(o, callback, type, visited) {
				visited = visited || {};

				var objId = _.util.objId;

				for (var i in o) {
					if (o.hasOwnProperty(i)) {
						callback.call(o, i, o[i], type || i);

						var property = o[i],
						    propertyType = _.util.type(property);

						if (propertyType === 'Object' && !visited[objId(property)]) {
							visited[objId(property)] = true;
							DFS(property, callback, null, visited);
						}
						else if (propertyType === 'Array' && !visited[objId(property)]) {
							visited[objId(property)] = true;
							DFS(property, callback, i, visited);
						}
					}
				}
			}
		},

		plugins: {},

		/**
		 * This is the most high-level function in Prism’s API.
		 * It fetches all the elements that have a `.language-xxxx` class and then calls {@link Prism.highlightElement} on
		 * each one of them.
		 *
		 * This is equivalent to `Prism.highlightAllUnder(document, async, callback)`.
		 *
		 * @param {boolean} [async=false] Same as in {@link Prism.highlightAllUnder}.
		 * @param {HighlightCallback} [callback] Same as in {@link Prism.highlightAllUnder}.
		 * @memberof Prism
		 * @public
		 */
		highlightAll: function(async, callback) {
			_.highlightAllUnder(document, async, callback);
		},

		/**
		 * Fetches all the descendants of `container` that have a `.language-xxxx` class and then calls
		 * {@link Prism.highlightElement} on each one of them.
		 *
		 * The following hooks will be run:
		 * 1. `before-highlightall`
		 * 2. `before-all-elements-highlight`
		 * 3. All hooks of {@link Prism.highlightElement} for each element.
		 *
		 * @param {ParentNode} container The root element, whose descendants that have a `.language-xxxx` class will be highlighted.
		 * @param {boolean} [async=false] Whether each element is to be highlighted asynchronously using Web Workers.
		 * @param {HighlightCallback} [callback] An optional callback to be invoked on each element after its highlighting is done.
		 * @memberof Prism
		 * @public
		 */
		highlightAllUnder: function(container, async, callback) {
			var env = {
				callback: callback,
				container: container,
				selector: 'code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code'
			};

			_.hooks.run('before-highlightall', env);

			env.elements = Array.prototype.slice.apply(env.container.querySelectorAll(env.selector));

			_.hooks.run('before-all-elements-highlight', env);

			for (var i = 0, element; element = env.elements[i++];) {
				_.highlightElement(element, async === true, env.callback);
			}
		},

		/**
		 * Highlights the code inside a single element.
		 *
		 * The following hooks will be run:
		 * 1. `before-sanity-check`
		 * 2. `before-highlight`
		 * 3. All hooks of {@link Prism.highlight}. These hooks will be run by an asynchronous worker if `async` is `true`.
		 * 4. `before-insert`
		 * 5. `after-highlight`
		 * 6. `complete`
		 *
		 * Some the above hooks will be skipped if the element doesn't contain any text or there is no grammar loaded for
		 * the element's language.
		 *
		 * @param {Element} element The element containing the code.
		 * It must have a class of `language-xxxx` to be processed, where `xxxx` is a valid language identifier.
		 * @param {boolean} [async=false] Whether the element is to be highlighted asynchronously using Web Workers
		 * to improve performance and avoid blocking the UI when highlighting very large chunks of code. This option is
		 * [disabled by default](https://prismjs.com/faq.html#why-is-asynchronous-highlighting-disabled-by-default).
		 *
		 * Note: All language definitions required to highlight the code must be included in the main `prism.js` file for
		 * asynchronous highlighting to work. You can build your own bundle on the
		 * [Download page](https://prismjs.com/download.html).
		 * @param {HighlightCallback} [callback] An optional callback to be invoked after the highlighting is done.
		 * Mostly useful when `async` is `true`, since in that case, the highlighting is done asynchronously.
		 * @memberof Prism
		 * @public
		 */
		highlightElement: function(element, async, callback) {
			// Find language
			var language = _.util.getLanguage(element);
			var grammar = _.languages[language];

			// Set language on the element, if not present
			element.className = element.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;

			// Set language on the parent, for styling
			var parent = element.parentElement;
			if (parent && parent.nodeName.toLowerCase() === 'pre') {
				parent.className = parent.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;
			}

			var code = element.textContent;

			var env = {
				element: element,
				language: language,
				grammar: grammar,
				code: code
			};

			function insertHighlightedCode(highlightedCode) {
				env.highlightedCode = highlightedCode;

				_.hooks.run('before-insert', env);

				env.element.innerHTML = env.highlightedCode;

				_.hooks.run('after-highlight', env);
				_.hooks.run('complete', env);
				callback && callback.call(env.element);
			}

			_.hooks.run('before-sanity-check', env);

			if (!env.code) {
				_.hooks.run('complete', env);
				callback && callback.call(env.element);
				return;
			}

			_.hooks.run('before-highlight', env);

			if (!env.grammar) {
				insertHighlightedCode(_.util.encode(env.code));
				return;
			}

			if (async && _self.Worker) {
				var worker = new Worker(_.filename);

				worker.onmessage = function(evt) {
					insertHighlightedCode(evt.data);
				};

				worker.postMessage(JSON.stringify({
					language: env.language,
					code: env.code,
					immediateClose: true
				}));
			}
			else {
				insertHighlightedCode(_.highlight(env.code, env.grammar, env.language));
			}
		},

		/**
		 * Low-level function, only use if you know what you’re doing. It accepts a string of text as input
		 * and the language definitions to use, and returns a string with the HTML produced.
		 *
		 * The following hooks will be run:
		 * 1. `before-tokenize`
		 * 2. `after-tokenize`
		 * 3. `wrap`: On each {@link Token}.
		 *
		 * @param {string} text A string with the code to be highlighted.
		 * @param {Grammar} grammar An object containing the tokens to use.
		 *
		 * Usually a language definition like `Prism.languages.markup`.
		 * @param {string} language The name of the language definition passed to `grammar`.
		 * @returns {string} The highlighted HTML.
		 * @memberof Prism
		 * @public
		 * @example
		 * Prism.highlight('var foo = true;', Prism.languages.javascript, 'javascript');
		 */
		highlight: function (text, grammar, language) {
			var env = {
				code: text,
				grammar: grammar,
				language: language
			};
			_.hooks.run('before-tokenize', env);
			env.tokens = _.tokenize(env.code, env.grammar);
			_.hooks.run('after-tokenize', env);
			return Token.stringify(_.util.encode(env.tokens), env.language);
		},

		/**
		 * This is the heart of Prism, and the most low-level function you can use. It accepts a string of text as input
		 * and the language definitions to use, and returns an array with the tokenized code.
		 *
		 * When the language definition includes nested tokens, the function is called recursively on each of these tokens.
		 *
		 * This method could be useful in other contexts as well, as a very crude parser.
		 *
		 * @param {string} text A string with the code to be highlighted.
		 * @param {Grammar} grammar An object containing the tokens to use.
		 *
		 * Usually a language definition like `Prism.languages.markup`.
		 * @returns {TokenStream} An array of strings and tokens, a token stream.
		 * @memberof Prism
		 * @public
		 * @example
		 * let code = `var foo = 0;`;
		 * let tokens = Prism.tokenize(code, Prism.languages.javascript);
		 * tokens.forEach(token => {
		 *     if (token instanceof Prism.Token && token.type === 'number') {
		 *         console.log(`Found numeric literal: ${token.content}`);
		 *     }
		 * });
		 */
		tokenize: function(text, grammar) {
			var rest = grammar.rest;
			if (rest) {
				for (var token in rest) {
					grammar[token] = rest[token];
				}

				delete grammar.rest;
			}

			var tokenList = new LinkedList();
			addAfter(tokenList, tokenList.head, text);

			matchGrammar(text, tokenList, grammar, tokenList.head, 0);

			return toArray(tokenList);
		},

		/**
		 * @namespace
		 * @memberof Prism
		 * @public
		 */
		hooks: {
			all: {},

			/**
			 * Adds the given callback to the list of callbacks for the given hook.
			 *
			 * The callback will be invoked when the hook it is registered for is run.
			 * Hooks are usually directly run by a highlight function but you can also run hooks yourself.
			 *
			 * One callback function can be registered to multiple hooks and the same hook multiple times.
			 *
			 * @param {string} name The name of the hook.
			 * @param {HookCallback} callback The callback function which is given environment variables.
			 * @public
			 */
			add: function (name, callback) {
				var hooks = _.hooks.all;

				hooks[name] = hooks[name] || [];

				hooks[name].push(callback);
			},

			/**
			 * Runs a hook invoking all registered callbacks with the given environment variables.
			 *
			 * Callbacks will be invoked synchronously and in the order in which they were registered.
			 *
			 * @param {string} name The name of the hook.
			 * @param {Object<string, any>} env The environment variables of the hook passed to all callbacks registered.
			 * @public
			 */
			run: function (name, env) {
				var callbacks = _.hooks.all[name];

				if (!callbacks || !callbacks.length) {
					return;
				}

				for (var i=0, callback; callback = callbacks[i++];) {
					callback(env);
				}
			}
		},

		Token: Token
	};
	_self.Prism = _;


	// Typescript note:
	// The following can be used to import the Token type in JSDoc:
	//
	//   @typedef {InstanceType<import("./prism-core")["Token"]>} Token

	/**
	 * Creates a new token.
	 *
	 * @param {string} type See {@link Token#type type}
	 * @param {string | TokenStream} content See {@link Token#content content}
	 * @param {string|string[]} [alias] The alias(es) of the token.
	 * @param {string} [matchedStr=""] A copy of the full string this token was created from.
	 * @class
	 * @global
	 * @public
	 */
	function Token(type, content, alias, matchedStr) {
		/**
		 * The type of the token.
		 *
		 * This is usually the key of a pattern in a {@link Grammar}.
		 *
		 * @type {string}
		 * @see GrammarToken
		 * @public
		 */
		this.type = type;
		/**
		 * The strings or tokens contained by this token.
		 *
		 * This will be a token stream if the pattern matched also defined an `inside` grammar.
		 *
		 * @type {string | TokenStream}
		 * @public
		 */
		this.content = content;
		/**
		 * The alias(es) of the token.
		 *
		 * @type {string|string[]}
		 * @see GrammarToken
		 * @public
		 */
		this.alias = alias;
		// Copy of the full string this token was created from
		this.length = (matchedStr || '').length | 0;
	}

	/**
	 * A token stream is an array of strings and {@link Token Token} objects.
	 *
	 * Token streams have to fulfill a few properties that are assumed by most functions (mostly internal ones) that process
	 * them.
	 *
	 * 1. No adjacent strings.
	 * 2. No empty strings.
	 *
	 *    The only exception here is the token stream that only contains the empty string and nothing else.
	 *
	 * @typedef {Array<string | Token>} TokenStream
	 * @global
	 * @public
	 */

	/**
	 * Converts the given token or token stream to an HTML representation.
	 *
	 * The following hooks will be run:
	 * 1. `wrap`: On each {@link Token}.
	 *
	 * @param {string | Token | TokenStream} o The token or token stream to be converted.
	 * @param {string} language The name of current language.
	 * @returns {string} The HTML representation of the token or token stream.
	 * @memberof Token
	 * @static
	 */
	Token.stringify = function stringify(o, language) {
		if (typeof o == 'string') {
			return o;
		}
		if (Array.isArray(o)) {
			var s = '';
			o.forEach(function (e) {
				s += stringify(e, language);
			});
			return s;
		}

		var env = {
			type: o.type,
			content: stringify(o.content, language),
			tag: 'span',
			classes: ['token', o.type],
			attributes: {},
			language: language
		};

		var aliases = o.alias;
		if (aliases) {
			if (Array.isArray(aliases)) {
				Array.prototype.push.apply(env.classes, aliases);
			} else {
				env.classes.push(aliases);
			}
		}

		_.hooks.run('wrap', env);

		var attributes = '';
		for (var name in env.attributes) {
			attributes += ' ' + name + '="' + (env.attributes[name] || '').replace(/"/g, '&quot;') + '"';
		}

		return '<' + env.tag + ' class="' + env.classes.join(' ') + '"' + attributes + '>' + env.content + '</' + env.tag + '>';
	};

	/**
	 * @param {string} text
	 * @param {LinkedList<string | Token>} tokenList
	 * @param {any} grammar
	 * @param {LinkedListNode<string | Token>} startNode
	 * @param {number} startPos
	 * @param {RematchOptions} [rematch]
	 * @returns {void}
	 * @private
	 *
	 * @typedef RematchOptions
	 * @property {string} cause
	 * @property {number} reach
	 */
	function matchGrammar(text, tokenList, grammar, startNode, startPos, rematch) {
		for (var token in grammar) {
			if (!grammar.hasOwnProperty(token) || !grammar[token]) {
				continue;
			}

			var patterns = grammar[token];
			patterns = Array.isArray(patterns) ? patterns : [patterns];

			for (var j = 0; j < patterns.length; ++j) {
				if (rematch && rematch.cause == token + ',' + j) {
					return;
				}

				var patternObj = patterns[j],
					inside = patternObj.inside,
					lookbehind = !!patternObj.lookbehind,
					greedy = !!patternObj.greedy,
					lookbehindLength = 0,
					alias = patternObj.alias;

				if (greedy && !patternObj.pattern.global) {
					// Without the global flag, lastIndex won't work
					var flags = patternObj.pattern.toString().match(/[imsuy]*$/)[0];
					patternObj.pattern = RegExp(patternObj.pattern.source, flags + 'g');
				}

				/** @type {RegExp} */
				var pattern = patternObj.pattern || patternObj;

				for ( // iterate the token list and keep track of the current token/string position
					var currentNode = startNode.next, pos = startPos;
					currentNode !== tokenList.tail;
					pos += currentNode.value.length, currentNode = currentNode.next
				) {

					if (rematch && pos >= rematch.reach) {
						break;
					}

					var str = currentNode.value;

					if (tokenList.length > text.length) {
						// Something went terribly wrong, ABORT, ABORT!
						return;
					}

					if (str instanceof Token) {
						continue;
					}

					var removeCount = 1; // this is the to parameter of removeBetween

					if (greedy && currentNode != tokenList.tail.prev) {
						pattern.lastIndex = pos;
						var match = pattern.exec(text);
						if (!match) {
							break;
						}

						var from = match.index + (lookbehind && match[1] ? match[1].length : 0);
						var to = match.index + match[0].length;
						var p = pos;

						// find the node that contains the match
						p += currentNode.value.length;
						while (from >= p) {
							currentNode = currentNode.next;
							p += currentNode.value.length;
						}
						// adjust pos (and p)
						p -= currentNode.value.length;
						pos = p;

						// the current node is a Token, then the match starts inside another Token, which is invalid
						if (currentNode.value instanceof Token) {
							continue;
						}

						// find the last node which is affected by this match
						for (
							var k = currentNode;
							k !== tokenList.tail && (p < to || typeof k.value === 'string');
							k = k.next
						) {
							removeCount++;
							p += k.value.length;
						}
						removeCount--;

						// replace with the new match
						str = text.slice(pos, p);
						match.index -= pos;
					} else {
						pattern.lastIndex = 0;

						var match = pattern.exec(str);
					}

					if (!match) {
						continue;
					}

					if (lookbehind) {
						lookbehindLength = match[1] ? match[1].length : 0;
					}

					var from = match.index + lookbehindLength,
						matchStr = match[0].slice(lookbehindLength),
						to = from + matchStr.length,
						before = str.slice(0, from),
						after = str.slice(to);

					var reach = pos + str.length;
					if (rematch && reach > rematch.reach) {
						rematch.reach = reach;
					}

					var removeFrom = currentNode.prev;

					if (before) {
						removeFrom = addAfter(tokenList, removeFrom, before);
						pos += before.length;
					}

					removeRange(tokenList, removeFrom, removeCount);

					var wrapped = new Token(token, inside ? _.tokenize(matchStr, inside) : matchStr, alias, matchStr);
					currentNode = addAfter(tokenList, removeFrom, wrapped);

					if (after) {
						addAfter(tokenList, currentNode, after);
					}

					if (removeCount > 1) {
						// at least one Token object was removed, so we have to do some rematching
						// this can only happen if the current pattern is greedy
						matchGrammar(text, tokenList, grammar, currentNode.prev, pos, {
							cause: token + ',' + j,
							reach: reach
						});
					}
				}
			}
		}
	}

	/**
	 * @typedef LinkedListNode
	 * @property {T} value
	 * @property {LinkedListNode<T> | null} prev The previous node.
	 * @property {LinkedListNode<T> | null} next The next node.
	 * @template T
	 * @private
	 */

	/**
	 * @template T
	 * @private
	 */
	function LinkedList() {
		/** @type {LinkedListNode<T>} */
		var head = { value: null, prev: null, next: null };
		/** @type {LinkedListNode<T>} */
		var tail = { value: null, prev: head, next: null };
		head.next = tail;

		/** @type {LinkedListNode<T>} */
		this.head = head;
		/** @type {LinkedListNode<T>} */
		this.tail = tail;
		this.length = 0;
	}

	/**
	 * Adds a new node with the given value to the list.
	 * @param {LinkedList<T>} list
	 * @param {LinkedListNode<T>} node
	 * @param {T} value
	 * @returns {LinkedListNode<T>} The added node.
	 * @template T
	 */
	function addAfter(list, node, value) {
		// assumes that node != list.tail && values.length >= 0
		var next = node.next;

		var newNode = { value: value, prev: node, next: next };
		node.next = newNode;
		next.prev = newNode;
		list.length++;

		return newNode;
	}
	/**
	 * Removes `count` nodes after the given node. The given node will not be removed.
	 * @param {LinkedList<T>} list
	 * @param {LinkedListNode<T>} node
	 * @param {number} count
	 * @template T
	 */
	function removeRange(list, node, count) {
		var next = node.next;
		for (var i = 0; i < count && next !== list.tail; i++) {
			next = next.next;
		}
		node.next = next;
		next.prev = node;
		list.length -= i;
	}
	/**
	 * @param {LinkedList<T>} list
	 * @returns {T[]}
	 * @template T
	 */
	function toArray(list) {
		var array = [];
		var node = list.head.next;
		while (node !== list.tail) {
			array.push(node.value);
			node = node.next;
		}
		return array;
	}


	if (!_self.document) {
		if (!_self.addEventListener) {
			// in Node.js
			return _;
		}

		if (!_.disableWorkerMessageHandler) {
			// In worker
			_self.addEventListener('message', function (evt) {
				var message = JSON.parse(evt.data),
					lang = message.language,
					code = message.code,
					immediateClose = message.immediateClose;

				_self.postMessage(_.highlight(code, _.languages[lang], lang));
				if (immediateClose) {
					_self.close();
				}
			}, false);
		}

		return _;
	}

	// Get current script and highlight
	var script = _.util.currentScript();

	if (script) {
		_.filename = script.src;

		if (script.hasAttribute('data-manual')) {
			_.manual = true;
		}
	}

	function highlightAutomaticallyCallback() {
		if (!_.manual) {
			_.highlightAll();
		}
	}

	if (!_.manual) {
		// If the document state is "loading", then we'll use DOMContentLoaded.
		// If the document state is "interactive" and the prism.js script is deferred, then we'll also use the
		// DOMContentLoaded event because there might be some plugins or languages which have also been deferred and they
		// might take longer one animation frame to execute which can create a race condition where only some plugins have
		// been loaded when Prism.highlightAll() is executed, depending on how fast resources are loaded.
		// See https://github.com/PrismJS/prism/issues/2102
		var readyState = document.readyState;
		if (readyState === 'loading' || readyState === 'interactive' && script && script.defer) {
			document.addEventListener('DOMContentLoaded', highlightAutomaticallyCallback);
		} else {
			if (window.requestAnimationFrame) {
				window.requestAnimationFrame(highlightAutomaticallyCallback);
			} else {
				window.setTimeout(highlightAutomaticallyCallback, 16);
			}
		}
	}

	return _;

	})(_self);

	if ( module.exports) {
		module.exports = Prism;
	}

	// hack for components to work correctly in node.js
	if (typeof commonjsGlobal !== 'undefined') {
		commonjsGlobal.Prism = Prism;
	}

	// some additional documentation/types

	/**
	 * The expansion of a simple `RegExp` literal to support additional properties.
	 *
	 * @typedef GrammarToken
	 * @property {RegExp} pattern The regular expression of the token.
	 * @property {boolean} [lookbehind=false] If `true`, then the first capturing group of `pattern` will (effectively)
	 * behave as a lookbehind group meaning that the captured text will not be part of the matched text of the new token.
	 * @property {boolean} [greedy=false] Whether the token is greedy.
	 * @property {string|string[]} [alias] An optional alias or list of aliases.
	 * @property {Grammar} [inside] The nested grammar of this token.
	 *
	 * The `inside` grammar will be used to tokenize the text value of each token of this kind.
	 *
	 * This can be used to make nested and even recursive language definitions.
	 *
	 * Note: This can cause infinite recursion. Be careful when you embed different languages or even the same language into
	 * each another.
	 * @global
	 * @public
	*/

	/**
	 * @typedef Grammar
	 * @type {Object<string, RegExp | GrammarToken | Array<RegExp | GrammarToken>>}
	 * @property {Grammar} [rest] An optional grammar object that will be appended to this grammar.
	 * @global
	 * @public
	 */

	/**
	 * A function which will invoked after an element was successfully highlighted.
	 *
	 * @callback HighlightCallback
	 * @param {Element} element The element successfully highlighted.
	 * @returns {void}
	 * @global
	 * @public
	*/

	/**
	 * @callback HookCallback
	 * @param {Object<string, any>} env The environment variables of the hook.
	 * @returns {void}
	 * @global
	 * @public
	 */


	/* **********************************************
	     Begin prism-markup.js
	********************************************** */

	Prism.languages.markup = {
		'comment': /<!--[\s\S]*?-->/,
		'prolog': /<\?[\s\S]+?\?>/,
		'doctype': {
			// https://www.w3.org/TR/xml/#NT-doctypedecl
			pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i,
			greedy: true,
			inside: {
				'internal-subset': {
					pattern: /(\[)[\s\S]+(?=\]>$)/,
					lookbehind: true,
					greedy: true,
					inside: null // see below
				},
				'string': {
					pattern: /"[^"]*"|'[^']*'/,
					greedy: true
				},
				'punctuation': /^<!|>$|[[\]]/,
				'doctype-tag': /^DOCTYPE/,
				'name': /[^\s<>'"]+/
			}
		},
		'cdata': /<!\[CDATA\[[\s\S]*?]]>/i,
		'tag': {
			pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/,
			greedy: true,
			inside: {
				'tag': {
					pattern: /^<\/?[^\s>\/]+/,
					inside: {
						'punctuation': /^<\/?/,
						'namespace': /^[^\s>\/:]+:/
					}
				},
				'attr-value': {
					pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
					inside: {
						'punctuation': [
							{
								pattern: /^=/,
								alias: 'attr-equals'
							},
							/"|'/
						]
					}
				},
				'punctuation': /\/?>/,
				'attr-name': {
					pattern: /[^\s>\/]+/,
					inside: {
						'namespace': /^[^\s>\/:]+:/
					}
				}

			}
		},
		'entity': [
			{
				pattern: /&[\da-z]{1,8};/i,
				alias: 'named-entity'
			},
			/&#x?[\da-f]{1,8};/i
		]
	};

	Prism.languages.markup['tag'].inside['attr-value'].inside['entity'] =
		Prism.languages.markup['entity'];
	Prism.languages.markup['doctype'].inside['internal-subset'].inside = Prism.languages.markup;

	// Plugin to make entity title show the real entity, idea by Roman Komarov
	Prism.hooks.add('wrap', function (env) {

		if (env.type === 'entity') {
			env.attributes['title'] = env.content.replace(/&amp;/, '&');
		}
	});

	Object.defineProperty(Prism.languages.markup.tag, 'addInlined', {
		/**
		 * Adds an inlined language to markup.
		 *
		 * An example of an inlined language is CSS with `<style>` tags.
		 *
		 * @param {string} tagName The name of the tag that contains the inlined language. This name will be treated as
		 * case insensitive.
		 * @param {string} lang The language key.
		 * @example
		 * addInlined('style', 'css');
		 */
		value: function addInlined(tagName, lang) {
			var includedCdataInside = {};
			includedCdataInside['language-' + lang] = {
				pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i,
				lookbehind: true,
				inside: Prism.languages[lang]
			};
			includedCdataInside['cdata'] = /^<!\[CDATA\[|\]\]>$/i;

			var inside = {
				'included-cdata': {
					pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
					inside: includedCdataInside
				}
			};
			inside['language-' + lang] = {
				pattern: /[\s\S]+/,
				inside: Prism.languages[lang]
			};

			var def = {};
			def[tagName] = {
				pattern: RegExp(/(<__[\s\S]*?>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function () { return tagName; }), 'i'),
				lookbehind: true,
				greedy: true,
				inside: inside
			};

			Prism.languages.insertBefore('markup', 'cdata', def);
		}
	});

	Prism.languages.html = Prism.languages.markup;
	Prism.languages.mathml = Prism.languages.markup;
	Prism.languages.svg = Prism.languages.markup;

	Prism.languages.xml = Prism.languages.extend('markup', {});
	Prism.languages.ssml = Prism.languages.xml;
	Prism.languages.atom = Prism.languages.xml;
	Prism.languages.rss = Prism.languages.xml;


	/* **********************************************
	     Begin prism-css.js
	********************************************** */

	(function (Prism) {

		var string = /("|')(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/;

		Prism.languages.css = {
			'comment': /\/\*[\s\S]*?\*\//,
			'atrule': {
				pattern: /@[\w-]+[\s\S]*?(?:;|(?=\s*\{))/,
				inside: {
					'rule': /^@[\w-]+/,
					'selector-function-argument': {
						pattern: /(\bselector\s*\((?!\s*\))\s*)(?:[^()]|\((?:[^()]|\([^()]*\))*\))+?(?=\s*\))/,
						lookbehind: true,
						alias: 'selector'
					},
					'keyword': {
						pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
						lookbehind: true
					}
					// See rest below
				}
			},
			'url': {
				// https://drafts.csswg.org/css-values-3/#urls
				pattern: RegExp('\\burl\\((?:' + string.source + '|' + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ')\\)', 'i'),
				greedy: true,
				inside: {
					'function': /^url/i,
					'punctuation': /^\(|\)$/,
					'string': {
						pattern: RegExp('^' + string.source + '$'),
						alias: 'url'
					}
				}
			},
			'selector': RegExp('[^{}\\s](?:[^{};"\']|' + string.source + ')*?(?=\\s*\\{)'),
			'string': {
				pattern: string,
				greedy: true
			},
			'property': /[-_a-z\xA0-\uFFFF][-\w\xA0-\uFFFF]*(?=\s*:)/i,
			'important': /!important\b/i,
			'function': /[-a-z0-9]+(?=\()/i,
			'punctuation': /[(){};:,]/
		};

		Prism.languages.css['atrule'].inside.rest = Prism.languages.css;

		var markup = Prism.languages.markup;
		if (markup) {
			markup.tag.addInlined('style', 'css');

			Prism.languages.insertBefore('inside', 'attr-value', {
				'style-attr': {
					pattern: /\s*style=("|')(?:\\[\s\S]|(?!\1)[^\\])*\1/i,
					inside: {
						'attr-name': {
							pattern: /^\s*style/i,
							inside: markup.tag.inside
						},
						'punctuation': /^\s*=\s*['"]|['"]\s*$/,
						'attr-value': {
							pattern: /.+/i,
							inside: Prism.languages.css
						}
					},
					alias: 'language-css'
				}
			}, markup.tag);
		}

	}(Prism));


	/* **********************************************
	     Begin prism-clike.js
	********************************************** */

	Prism.languages.clike = {
		'comment': [
			{
				pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
				lookbehind: true
			},
			{
				pattern: /(^|[^\\:])\/\/.*/,
				lookbehind: true,
				greedy: true
			}
		],
		'string': {
			pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
			greedy: true
		},
		'class-name': {
			pattern: /(\b(?:class|interface|extends|implements|trait|instanceof|new)\s+|\bcatch\s+\()[\w.\\]+/i,
			lookbehind: true,
			inside: {
				'punctuation': /[.\\]/
			}
		},
		'keyword': /\b(?:if|else|while|do|for|return|in|instanceof|function|new|try|throw|catch|finally|null|break|continue)\b/,
		'boolean': /\b(?:true|false)\b/,
		'function': /\w+(?=\()/,
		'number': /\b0x[\da-f]+\b|(?:\b\d+\.?\d*|\B\.\d+)(?:e[+-]?\d+)?/i,
		'operator': /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
		'punctuation': /[{}[\];(),.:]/
	};


	/* **********************************************
	     Begin prism-javascript.js
	********************************************** */

	Prism.languages.javascript = Prism.languages.extend('clike', {
		'class-name': [
			Prism.languages.clike['class-name'],
			{
				pattern: /(^|[^$\w\xA0-\uFFFF])[_$A-Z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\.(?:prototype|constructor))/,
				lookbehind: true
			}
		],
		'keyword': [
			{
				pattern: /((?:^|})\s*)(?:catch|finally)\b/,
				lookbehind: true
			},
			{
				pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|for|from|function|(?:get|set)(?=\s*[\[$\w\xA0-\uFFFF])|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
				lookbehind: true
			},
		],
		'number': /\b(?:(?:0[xX](?:[\dA-Fa-f](?:_[\dA-Fa-f])?)+|0[bB](?:[01](?:_[01])?)+|0[oO](?:[0-7](?:_[0-7])?)+)n?|(?:\d(?:_\d)?)+n|NaN|Infinity)\b|(?:\b(?:\d(?:_\d)?)+\.?(?:\d(?:_\d)?)*|\B\.(?:\d(?:_\d)?)+)(?:[Ee][+-]?(?:\d(?:_\d)?)+)?/,
		// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
		'function': /#?[_$a-zA-Z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
		'operator': /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
	});

	Prism.languages.javascript['class-name'][0].pattern = /(\b(?:class|interface|extends|implements|instanceof|new)\s+)[\w.\\]+/;

	Prism.languages.insertBefore('javascript', 'keyword', {
		'regex': {
			pattern: /((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)\/(?:\[(?:[^\]\\\r\n]|\\.)*]|\\.|[^/\\\[\r\n])+\/[gimyus]{0,6}(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/,
			lookbehind: true,
			greedy: true,
			inside: {
				'regex-source': {
					pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
					lookbehind: true,
					alias: 'language-regex',
					inside: Prism.languages.regex
				},
				'regex-flags': /[a-z]+$/,
				'regex-delimiter': /^\/|\/$/
			}
		},
		// This must be declared before keyword because we use "function" inside the look-forward
		'function-variable': {
			pattern: /#?[_$a-zA-Z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|[_$a-zA-Z\xA0-\uFFFF][$\w\xA0-\uFFFF]*)\s*=>))/,
			alias: 'function'
		},
		'parameter': [
			{
				pattern: /(function(?:\s+[_$A-Za-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*)?\s*\(\s*)(?!\s)(?:[^()]|\([^()]*\))+?(?=\s*\))/,
				lookbehind: true,
				inside: Prism.languages.javascript
			},
			{
				pattern: /[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*=>)/i,
				inside: Prism.languages.javascript
			},
			{
				pattern: /(\(\s*)(?!\s)(?:[^()]|\([^()]*\))+?(?=\s*\)\s*=>)/,
				lookbehind: true,
				inside: Prism.languages.javascript
			},
			{
				pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:[_$A-Za-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()]|\([^()]*\))+?(?=\s*\)\s*\{)/,
				lookbehind: true,
				inside: Prism.languages.javascript
			}
		],
		'constant': /\b[A-Z](?:[A-Z_]|\dx?)*\b/
	});

	Prism.languages.insertBefore('javascript', 'string', {
		'template-string': {
			pattern: /`(?:\\[\s\S]|\${(?:[^{}]|{(?:[^{}]|{[^}]*})*})+}|(?!\${)[^\\`])*`/,
			greedy: true,
			inside: {
				'template-punctuation': {
					pattern: /^`|`$/,
					alias: 'string'
				},
				'interpolation': {
					pattern: /((?:^|[^\\])(?:\\{2})*)\${(?:[^{}]|{(?:[^{}]|{[^}]*})*})+}/,
					lookbehind: true,
					inside: {
						'interpolation-punctuation': {
							pattern: /^\${|}$/,
							alias: 'punctuation'
						},
						rest: Prism.languages.javascript
					}
				},
				'string': /[\s\S]+/
			}
		}
	});

	if (Prism.languages.markup) {
		Prism.languages.markup.tag.addInlined('script', 'javascript');
	}

	Prism.languages.js = Prism.languages.javascript;


	/* **********************************************
	     Begin prism-file-highlight.js
	********************************************** */

	(function () {
		if (typeof self === 'undefined' || !self.Prism || !self.document) {
			return;
		}

		var Prism = window.Prism;

		var LOADING_MESSAGE = 'Loading…';
		var FAILURE_MESSAGE = function (status, message) {
			return '✖ Error ' + status + ' while fetching file: ' + message;
		};
		var FAILURE_EMPTY_MESSAGE = '✖ Error: File does not exist or is empty';

		var EXTENSIONS = {
			'js': 'javascript',
			'py': 'python',
			'rb': 'ruby',
			'ps1': 'powershell',
			'psm1': 'powershell',
			'sh': 'bash',
			'bat': 'batch',
			'h': 'c',
			'tex': 'latex'
		};

		var STATUS_ATTR = 'data-src-status';
		var STATUS_LOADING = 'loading';
		var STATUS_LOADED = 'loaded';
		var STATUS_FAILED = 'failed';

		var SELECTOR = 'pre[data-src]:not([' + STATUS_ATTR + '="' + STATUS_LOADED + '"])'
			+ ':not([' + STATUS_ATTR + '="' + STATUS_LOADING + '"])';

		var lang = /\blang(?:uage)?-([\w-]+)\b/i;

		/**
		 * Sets the Prism `language-xxxx` or `lang-xxxx` class to the given language.
		 *
		 * @param {HTMLElement} element
		 * @param {string} language
		 * @returns {void}
		 */
		function setLanguageClass(element, language) {
			var className = element.className;
			className = className.replace(lang, ' ') + ' language-' + language;
			element.className = className.replace(/\s+/g, ' ').trim();
		}


		Prism.hooks.add('before-highlightall', function (env) {
			env.selector += ', ' + SELECTOR;
		});

		Prism.hooks.add('before-sanity-check', function (env) {
			var pre = /** @type {HTMLPreElement} */ (env.element);
			if (pre.matches(SELECTOR)) {
				env.code = ''; // fast-path the whole thing and go to complete

				pre.setAttribute(STATUS_ATTR, STATUS_LOADING); // mark as loading

				// add code element with loading message
				var code = pre.appendChild(document.createElement('CODE'));
				code.textContent = LOADING_MESSAGE;

				var src = pre.getAttribute('data-src');

				var language = env.language;
				if (language === 'none') {
					// the language might be 'none' because there is no language set;
					// in this case, we want to use the extension as the language
					var extension = (/\.(\w+)$/.exec(src) || [, 'none'])[1];
					language = EXTENSIONS[extension] || extension;
				}

				// set language classes
				setLanguageClass(code, language);
				setLanguageClass(pre, language);

				// preload the language
				var autoloader = Prism.plugins.autoloader;
				if (autoloader) {
					autoloader.loadLanguages(language);
				}

				// load file
				var xhr = new XMLHttpRequest();
				xhr.open('GET', src, true);
				xhr.onreadystatechange = function () {
					if (xhr.readyState == 4) {
						if (xhr.status < 400 && xhr.responseText) {
							// mark as loaded
							pre.setAttribute(STATUS_ATTR, STATUS_LOADED);

							// highlight code
							code.textContent = xhr.responseText;
							Prism.highlightElement(code);

						} else {
							// mark as failed
							pre.setAttribute(STATUS_ATTR, STATUS_FAILED);

							if (xhr.status >= 400) {
								code.textContent = FAILURE_MESSAGE(xhr.status, xhr.statusText);
							} else {
								code.textContent = FAILURE_EMPTY_MESSAGE;
							}
						}
					}
				};
				xhr.send(null);
			}
		});

		Prism.plugins.fileHighlight = {
			/**
			 * Executes the File Highlight plugin for all matching `pre` elements under the given container.
			 *
			 * Note: Elements which are already loaded or currently loading will not be touched by this method.
			 *
			 * @param {ParentNode} [container=document]
			 */
			highlight: function highlight(container) {
				var elements = (container || document).querySelectorAll(SELECTOR);

				for (var i = 0, element; element = elements[i++];) {
					Prism.highlightElement(element);
				}
			}
		};

		var logged = false;
		/** @deprecated Use `Prism.plugins.fileHighlight.highlight` instead. */
		Prism.fileHighlight = function () {
			if (!logged) {
				console.warn('Prism.fileHighlight is deprecated. Use `Prism.plugins.fileHighlight.highlight` instead.');
				logged = true;
			}
			Prism.plugins.fileHighlight.highlight.apply(this, arguments);
		};

	})();
	});

	Prism.languages.graphql = {
		'comment': /#.*/,
		'description': {
			pattern: /(?:"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*")(?=\s*[a-z_])/i,
			greedy: true,
			alias: 'string',
			inside: {
				'language-markdown': {
					pattern: /(^"(?:"")?)(?!\1)[\s\S]+(?=\1$)/,
					lookbehind: true,
					inside: Prism.languages.markdown
				}
			}
		},
		'string': {
			pattern: /"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*"/,
			greedy: true
		},
		'number': /(?:\B-|\b)\d+(?:\.\d+)?(?:e[+-]?\d+)?\b/i,
		'boolean': /\b(?:true|false)\b/,
		'variable': /\$[a-z_]\w*/i,
		'directive': {
			pattern: /@[a-z_]\w*/i,
			alias: 'function'
		},
		'attr-name': {
			pattern: /[a-z_]\w*(?=\s*(?:\((?:[^()"]|"(?:\\.|[^\\"\r\n])*")*\))?:)/i,
			greedy: true
		},
		'class-name': {
			pattern: /(\b(?:enum|implements|interface|on|scalar|type|union)\s+|&\s*)[a-zA-Z_]\w*/,
			lookbehind: true
		},
		'fragment': {
			pattern: /(\bfragment\s+|\.{3}\s*(?!on\b))[a-zA-Z_]\w*/,
			lookbehind: true,
			alias: 'function'
		},
		'keyword': /\b(?:directive|enum|extend|fragment|implements|input|interface|mutation|on|query|repeatable|scalar|schema|subscription|type|union)\b/,
		'operator': /[!=|&]|\.{3}/,
		'punctuation': /[!(){}\[\]:=,]/,
		'constant': /\b(?!ID\b)[A-Z][A-Z_\d]*\b/
	};

	/**
	 * Original by Scott Helme.
	 *
	 * Reference: https://scotthelme.co.uk/csp-cheat-sheet/
	 *
	 * Supports the following:
	 *  - CSP Level 1
	 *  - CSP Level 2
	 *  - CSP Level 3
	 */

	Prism.languages.csp = {
		'directive':  {
			pattern: /\b(?:base-uri|block-all-mixed-content|(?:child|connect|default|font|frame|img|manifest|media|object|script|style|worker)-src|disown-opener|form-action|frame-ancestors|plugin-types|referrer|reflected-xss|report-to|report-uri|require-sri-for|sandbox|upgrade-insecure-requests)\b/i,
			alias: 'keyword'
		},
		'safe': {
			pattern: /'(?:self|none|strict-dynamic|(?:nonce-|sha(?:256|384|512)-)[a-zA-Z\d+=/]+)'/,
			alias: 'selector'
		},
		'unsafe': {
			pattern: /(?:'unsafe-inline'|'unsafe-eval'|'unsafe-hashed-attributes'|\*)/,
			alias: 'function'
		}
	};

	(function(Prism) {

	var javascript = Prism.util.clone(Prism.languages.javascript);

	Prism.languages.jsx = Prism.languages.extend('markup', javascript);
	Prism.languages.jsx.tag.pattern= /<\/?(?:[\w.:-]+\s*(?:\s+(?:[\w.:$-]+(?:=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s{'">=]+|\{(?:\{(?:\{[^{}]*\}|[^{}])*\}|[^{}])+\}))?|\{\s*\.{3}\s*[a-z_$][\w$]*(?:\.[a-z_$][\w$]*)*\s*\}))*\s*\/?)?>/i;

	Prism.languages.jsx.tag.inside['tag'].pattern = /^<\/?[^\s>\/]*/i;
	Prism.languages.jsx.tag.inside['attr-value'].pattern = /=(?!\{)(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">]+)/i;
	Prism.languages.jsx.tag.inside['tag'].inside['class-name'] = /^[A-Z]\w*(?:\.[A-Z]\w*)*$/;

	Prism.languages.insertBefore('inside', 'attr-name', {
		'spread': {
			pattern: /\{\s*\.{3}\s*[a-z_$][\w$]*(?:\.[a-z_$][\w$]*)*\s*\}/,
			inside: {
				'punctuation': /\.{3}|[{}.]/,
				'attr-value': /\w+/
			}
		}
	}, Prism.languages.jsx.tag);

	Prism.languages.insertBefore('inside', 'attr-value',{
		'script': {
			// Allow for two levels of nesting
			pattern: /=(?:\{(?:\{(?:\{[^{}]*\}|[^{}])*\}|[^{}])+\})/i,
			inside: {
				'script-punctuation': {
					pattern: /^=(?={)/,
					alias: 'punctuation'
				},
				rest: Prism.languages.jsx
			},
			'alias': 'language-javascript'
		}
	}, Prism.languages.jsx.tag);

	// The following will handle plain text inside tags
	var stringifyToken = function (token) {
		if (!token) {
			return '';
		}
		if (typeof token === 'string') {
			return token;
		}
		if (typeof token.content === 'string') {
			return token.content;
		}
		return token.content.map(stringifyToken).join('');
	};

	var walkTokens = function (tokens) {
		var openedTags = [];
		for (var i = 0; i < tokens.length; i++) {
			var token = tokens[i];
			var notTagNorBrace = false;

			if (typeof token !== 'string') {
				if (token.type === 'tag' && token.content[0] && token.content[0].type === 'tag') {
					// We found a tag, now find its kind

					if (token.content[0].content[0].content === '</') {
						// Closing tag
						if (openedTags.length > 0 && openedTags[openedTags.length - 1].tagName === stringifyToken(token.content[0].content[1])) {
							// Pop matching opening tag
							openedTags.pop();
						}
					} else {
						if (token.content[token.content.length - 1].content === '/>') ; else {
							// Opening tag
							openedTags.push({
								tagName: stringifyToken(token.content[0].content[1]),
								openedBraces: 0
							});
						}
					}
				} else if (openedTags.length > 0 && token.type === 'punctuation' && token.content === '{') {

					// Here we might have entered a JSX context inside a tag
					openedTags[openedTags.length - 1].openedBraces++;

				} else if (openedTags.length > 0 && openedTags[openedTags.length - 1].openedBraces > 0 && token.type === 'punctuation' && token.content === '}') {

					// Here we might have left a JSX context inside a tag
					openedTags[openedTags.length - 1].openedBraces--;

				} else {
					notTagNorBrace = true;
				}
			}
			if (notTagNorBrace || typeof token === 'string') {
				if (openedTags.length > 0 && openedTags[openedTags.length - 1].openedBraces === 0) {
					// Here we are inside a tag, and not inside a JSX context.
					// That's plain text: drop any tokens matched.
					var plainText = stringifyToken(token);

					// And merge text with adjacent text
					if (i < tokens.length - 1 && (typeof tokens[i + 1] === 'string' || tokens[i + 1].type === 'plain-text')) {
						plainText += stringifyToken(tokens[i + 1]);
						tokens.splice(i + 1, 1);
					}
					if (i > 0 && (typeof tokens[i - 1] === 'string' || tokens[i - 1].type === 'plain-text')) {
						plainText = stringifyToken(tokens[i - 1]) + plainText;
						tokens.splice(i - 1, 1);
						i--;
					}

					tokens[i] = new Prism.Token('plain-text', plainText, null, plainText);
				}
			}

			if (token.content && typeof token.content !== 'string') {
				walkTokens(token.content);
			}
		}
	};

	Prism.hooks.add('after-tokenize', function (env) {
		if (env.language !== 'jsx' && env.language !== 'tsx') {
			return;
		}
		walkTokens(env.tokens);
	});

	}(Prism));

	var _from = "magicpen-prism@^4.0.0";
	var _id = "magicpen-prism@4.1.1";
	var _inBundle = false;
	var _integrity = "sha512-WiW87nVxaipTFw2EO6Vp4KJ/PIyVtfrE33T8x8NqaYYj+eUrVxcnJS+GY/ioD+MwH4EnU1xBSnLxHcGFLAKrhw==";
	var _location = "/magicpen-prism";
	var _phantomChildren = {
	};
	var _requested = {
		type: "range",
		registry: true,
		raw: "magicpen-prism@^4.0.0",
		name: "magicpen-prism",
		escapedName: "magicpen-prism",
		rawSpec: "^4.0.0",
		saveSpec: null,
		fetchSpec: "^4.0.0"
	};
	var _requiredBy = [
		"/",
		"/evaldown"
	];
	var _resolved = "https://registry.npmjs.org/magicpen-prism/-/magicpen-prism-4.1.1.tgz";
	var _shasum = "0d1ad0d3a4d92f377b081c1534390cbef4b3d1cd";
	var _spec = "magicpen-prism@^4.0.0";
	var _where = "/home/andreas/work/unexpected-dom";
	var author = {
		name: "Andreas Lind",
		email: "andreaslindpetersen@gmail.com"
	};
	var bugs = {
		url: "https://github.com/unexpectedjs/magicpen-prism/issues"
	};
	var bundleDependencies = false;
	var dependencies = {
		prismjs: "^1.21.0"
	};
	var deprecated = false;
	var description = "Add syntax highlighting support to magicpen via prism.js";
	var devDependencies = {
		browserify: "^16.2.3",
		"bundle-collapser": "^1.3.0",
		coveralls: "^3.0.3",
		eslint: "^7.0.0",
		"eslint-config-prettier": "^6.9.0",
		"eslint-config-standard": "^14.1.0",
		"eslint-plugin-import": "^2.16.0",
		"eslint-plugin-mocha": "^8.0.0",
		"eslint-plugin-node": "^11.0.0",
		"eslint-plugin-promise": "^4.0.1",
		"eslint-plugin-standard": "^4.0.0",
		magicpen: "^6.2.1",
		mocha: "^7.0.0",
		nyc: "^15.0.0",
		prettier: "~2.0.1",
		unexpected: "^11.12.1"
	};
	var files = [
		"lib",
		"magicPenPrism.min.js"
	];
	var homepage = "https://github.com/unexpectedjs/magicpen-prism#readme";
	var main = "lib/magicPenPrism.js";
	var name = "magicpen-prism";
	var nyc = {
		include: [
			"lib/**"
		]
	};
	var repository = {
		type: "git",
		url: "git+https://github.com/unexpectedjs/magicpen-prism.git"
	};
	var scripts = {
		coverage: "NODE_ENV=development nyc --reporter=lcov --reporter=text --all -- npm test && echo google-chrome coverage/lcov-report/index.html",
		lint: "eslint . && prettier --check '**/*.js'",
		prepublish: "browserify -p bundle-collapser/plugin -e lib/magicPenPrism -s magicPenPrism > magicPenPrism.min.js",
		test: "mocha",
		"test:ci": "npm run coverage"
	};
	var version = "4.1.1";
	var _package = {
		_from: _from,
		_id: _id,
		_inBundle: _inBundle,
		_integrity: _integrity,
		_location: _location,
		_phantomChildren: _phantomChildren,
		_requested: _requested,
		_requiredBy: _requiredBy,
		_resolved: _resolved,
		_shasum: _shasum,
		_spec: _spec,
		_where: _where,
		author: author,
		bugs: bugs,
		bundleDependencies: bundleDependencies,
		dependencies: dependencies,
		deprecated: deprecated,
		description: description,
		devDependencies: devDependencies,
		files: files,
		homepage: homepage,
		main: main,
		name: name,
		nyc: nyc,
		repository: repository,
		scripts: scripts,
		version: version
	};

	var _package$1 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		_from: _from,
		_id: _id,
		_inBundle: _inBundle,
		_integrity: _integrity,
		_location: _location,
		_phantomChildren: _phantomChildren,
		_requested: _requested,
		_requiredBy: _requiredBy,
		_resolved: _resolved,
		_shasum: _shasum,
		_spec: _spec,
		_where: _where,
		author: author,
		bugs: bugs,
		bundleDependencies: bundleDependencies,
		dependencies: dependencies,
		deprecated: deprecated,
		description: description,
		devDependencies: devDependencies,
		files: files,
		homepage: homepage,
		main: main,
		name: name,
		nyc: nyc,
		repository: repository,
		scripts: scripts,
		version: version,
		'default': _package
	});

	var require$$4 = getCjsExportFromNamespace(_package$1);

	var oldPrismGlobal = commonjsGlobal.Prism;
	var prism$1 = (commonjsGlobal.Prism = prism);



	commonjsGlobal.Prism = oldPrismGlobal || prism$1;

	var defaultTheme = {
	  // Adapted from the default Prism theme:
	  prismComment: '#708090', // slategray
	  prismProlog: 'prismComment',
	  prismDoctype: 'prismComment',
	  prismCdata: 'prismComment',

	  prismPunctuation: '#999',

	  prismSymbol: '#905',
	  prismProperty: 'prismSymbol',
	  prismTag: 'prismSymbol',
	  prismBoolean: 'prismSymbol',
	  prismNumber: 'prismSymbol',
	  prismConstant: 'prismSymbol',
	  prismDeleted: 'prismSymbol',

	  prismString: '#690',
	  prismSelector: 'prismString',
	  prismAttrName: 'prismString',
	  prismChar: 'prismString',
	  prismBuiltin: 'prismString',
	  prismInserted: 'prismString',

	  prismOperator: '#a67f59',
	  prismVariable: 'prismOperator',
	  prismEntity: 'prismOperator',
	  prismUrl: 'prismOperator',
	  prismCssString: 'prismOperator',

	  prismKeyword: '#07a',
	  prismAtrule: 'prismKeyword',
	  prismAttrValue: 'prismKeyword',

	  prismFunction: '#DD4A68',

	  prismRegex: '#e90',
	  prismImportant: ['#e90', 'bold'],
	};

	var languageMapping = {
	  'text/html': 'markup',
	  'application/xml': 'markup',
	  'text/xml': 'markup',
	  'application/json': 'javascript',
	  'text/javascript': 'javascript',
	  'application/javascript': 'javascript',
	  'text/css': 'css',
	  html: 'markup',
	  xml: 'markup',
	  c: 'clike',
	  'c++': 'clike',
	  cpp: 'clike',
	  'c#': 'clike',
	  java: 'clike',
	  'application/graphql': 'graphql',
	  jsx: 'jsx',
	};

	function upperCamelCase(str) {
	  return str.replace(/(?:^|-)([a-z])/g, function ($0, ch) {
	    return ch.toUpperCase();
	  });
	}

	var magicPenPrism = {
	  name: 'magicpen-prism',
	  version: require$$4.version,
	  installInto: function (magicPen) {
	    magicPen.installTheme(defaultTheme);

	    magicPen.addStyle(
	      'code',
	      function (sourceText, language) {
	        if (language in languageMapping) {
	          language = languageMapping[language];
	        } else if (/\+xml\b/.test(language)) {
	          language = 'markup';
	        }
	        if (!(language in prism$1.languages)) {
	          return this.text(sourceText);
	        }
	        var that = this;
	        var capitalizedLanguage = upperCamelCase(language);
	        var languageDefinition = prism$1.languages[language];

	        function printTokens(token, parentStyle) {
	          if (Array.isArray(token)) {
	            token.forEach(function (subToken) {
	              printTokens(subToken, parentStyle);
	            });
	          } else if (typeof token === 'string') {
	            var upperCamelCasedParentStyle = upperCamelCase(parentStyle);
	            token = token.replace(/&lt;/g, '<');
	            if (
	              that['prism' + capitalizedLanguage + upperCamelCasedParentStyle]
	            ) {
	              that['prism' + capitalizedLanguage + upperCamelCasedParentStyle](
	                token
	              );
	            } else if (that['prism' + upperCamelCasedParentStyle]) {
	              that['prism' + upperCamelCasedParentStyle](token);
	            } else if (
	              languageDefinition[parentStyle] &&
	              languageDefinition[parentStyle].alias
	            ) {
	              printTokens(token, languageDefinition[parentStyle].alias);
	            } else {
	              that.text(token);
	            }
	          } else {
	            printTokens(token.content, token.type);
	          }
	        }
	        printTokens(
	          prism$1.tokenize(sourceText, prism$1.languages[language]),
	          'text'
	        );
	      },
	      true
	    );
	  },
	};

	/* global DOMParser */


	function getJSDOM() {
	  try {
	    return commonjsRequire('' + 'jsdom');
	  } catch (err) {
	    throw new Error(
	      'unexpected-dom: Running outside a browser (or in a browser without DOMParser), but could not find the `jsdom` module. Please npm install jsdom to make this work.'
	    );
	  }
	}

	function getHtmlDocument(str) {
	  if (typeof DOMParser !== 'undefined') {
	    return new DOMParser().parseFromString(str, 'text/html');
	  } else if (
	    typeof document !== 'undefined' &&
	    document.implementation &&
	    document.implementation.createHTMLDocument
	  ) {
	    var htmlDocument = document.implementation.createHTMLDocument('');
	    htmlDocument.open();
	    htmlDocument.write(str);
	    htmlDocument.close();
	    return htmlDocument;
	  } else {
	    var jsdom = getJSDOM();

	    return jsdom.JSDOM
	      ? new jsdom.JSDOM(str).window.document
	      : jsdom.jsdom(str);
	  }
	}

	function parseHtml(str, isFragment) {
	  if (isFragment) {
	    str = "<html><head></head><body>" + str + "</body></html>";
	  }
	  var htmlDocument = getHtmlDocument(str);

	  if (isFragment) {
	    var body = htmlDocument.body;
	    var documentFragment = htmlDocument.createDocumentFragment();
	    if (body) {
	      for (var i = 0; i < body.childNodes.length; i += 1) {
	        documentFragment.appendChild(body.childNodes[i].cloneNode(true));
	      }
	    }
	    return documentFragment;
	  } else {
	    return htmlDocument;
	  }
	}

	function parseXml(str) {
	  if (typeof DOMParser !== 'undefined') {
	    return new DOMParser().parseFromString(str, 'text/xml');
	  } else {
	    var jsdom = getJSDOM();

	    if (jsdom.JSDOM) {
	      return new jsdom.JSDOM(str, { contentType: 'text/xml' }).window.document;
	    } else {
	      return jsdom.jsdom(str, { parsingMode: 'xml' });
	    }
	  }
	}

	// From html-minifier
	var enumeratedAttributeValues = {
	  draggable: ['true', 'false'], // defaults to 'auto'
	};

	var matchSimpleAttribute = /^(?:allowfullscreen|async|autofocus|autoplay|checked|compact|controls|declare|default|defaultchecked|defaultmuted|defaultselected|defer|disabled|enabled|formnovalidate|hidden|indeterminate|inert|ismap|itemscope|loop|multiple|muted|nohref|noresize|noshade|novalidate|nowrap|open|pauseonexit|readonly|required|reversed|scoped|seamless|selected|sortable|spellcheck|truespeed|typemustmatch|visible)$/i;

	function isBooleanAttribute(attrName) {
	  return matchSimpleAttribute.test(attrName);
	}

	function isEnumeratedAttribute(attrName) {
	  return attrName in enumeratedAttributeValues;
	}

	function validateStyles(expect, str) {
	  var invalidStyles = str
	    .split(';')
	    .filter(
	      function (part) { return !/^\s*(\w|-)+\s*:\s*(#(?:[0-9a-fA-F]{3}){1,2}|[^#]+)\s*$|^$/.test(part); }
	    );

	  if (invalidStyles.length > 0) {
	    expect.errorMode = 'nested';
	    expect.fail(
	      'Expectation contains invalid styles: {0}',
	      invalidStyles.join(';')
	    );
	  }
	}

	function styleStringToObject(str) {
	  var styles = {};

	  str.split(';').forEach(function (rule) {
	    var colonIndex = rule.indexOf(':');

	    // Guard against empty touples
	    if (colonIndex !== -1) {
	      var key = rule.slice(0, colonIndex).trim();
	      var value = rule.slice(colonIndex + 1).trim();

	      styles[key] = value;
	    }
	  });

	  return styles;
	}

	function getClassNamesFromAttributeValue(attributeValue) {
	  if (attributeValue === null) {
	    return [];
	  }

	  if (attributeValue === '') {
	    return [];
	  }

	  var classNames = attributeValue.split(/\s+/);
	  if (classNames.length === 1 && classNames[0] === '') {
	    classNames.pop();
	  }
	  return classNames;
	}

	function isInsideHtmlDocument(node) {
	  var ownerDocument =
	    node.nodeType === 9 && node.documentElement && node.implementation
	      ? node
	      : node.ownerDocument;

	  if (ownerDocument.contentType) {
	    return ownerDocument.contentType === 'text/html';
	  } else {
	    return ownerDocument.toString() === '[object HTMLDocument]';
	  }
	}

	function getAttributes(element) {
	  var isHtml = isInsideHtmlDocument(element);
	  var attrs = element.attributes;
	  var result = {};

	  for (var i = 0; i < attrs.length; i += 1) {
	    if (attrs[i].name === 'class') {
	      result[attrs[i].name] =
	        (attrs[i].value && attrs[i].value.split(' ')) || [];
	    } else if (attrs[i].name === 'style') {
	      result[attrs[i].name] = styleStringToObject(attrs[i].value);
	    } else {
	      result[attrs[i].name] =
	        isHtml && isBooleanAttribute(attrs[i].name)
	          ? true
	          : attrs[i].value || '';
	    }
	  }

	  return result;
	}

	function getStates(element) {
	  var result = {};

	  try {
	    result.focused = element.ownerDocument.activeElement === element;
	  } catch (err) {
	    // The document might not be in a window, and thus not able to have an activeElement
	  }

	  return result;
	}

	function entitify(value) {
	  return String(value)
	    .replace(/&/g, '&amp;')
	    .replace(/"/g, '&quot;')
	    .replace(/</g, '&lt;');
	}

	function isVoidElement(elementName) {
	  return /(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr)/i.test(
	    elementName
	  );
	}

	function writeAttributeToMagicPen(output, attributeName, value, isHtml) {
	  output.prismAttrName(attributeName);
	  if (!isHtml || !isBooleanAttribute(attributeName)) {
	    if (attributeName === 'class') {
	      value = value.join(' ');
	    } else if (attributeName === 'style') {
	      value = Object.keys(value)
	        .map(function (cssProp) { return (cssProp + ": " + (value[cssProp])); })
	        .join('; ');
	    }
	    output
	      .prismPunctuation('="')
	      .prismAttrValue(entitify(value))
	      .prismPunctuation('"');
	  }
	}

	function stringifyAttribute(attributeName, value) {
	  if (
	    isBooleanAttribute(attributeName) ||
	    isEnumeratedAttribute(attributeName)
	  ) {
	    return attributeName;
	  } else if (attributeName === 'class') {
	    return ("class=\"" + (value.join(' ')) + "\""); // FIXME: entitify
	  } else if (attributeName === 'style') {
	    return ("style=\"" + (Object.keys(value)
	      // FIXME: entitify
	      .map(function (cssProp) { return [cssProp, value[cssProp]].join(': '); })
	      .join('; ')) + "\"");
	  } else {
	    return (attributeName + "=\"" + (entitify(value)) + "\"");
	  }
	}

	function stringifyStartTag(element) {
	  var elementName = isInsideHtmlDocument(element)
	    ? element.nodeName.toLowerCase()
	    : element.nodeName;
	  var str = "<" + elementName;
	  var attrs = getAttributes(element);
	  var states = getStates(element);

	  Object.keys(attrs).forEach(function (key) {
	    str += " " + (stringifyAttribute(key, attrs[key]));
	  });

	  if (elementName !== 'body' && states.focused) {
	    str += ' :focus';
	  }

	  str += '>';
	  return str;
	}

	function stringifyEndTag(element) {
	  var isHtml = isInsideHtmlDocument(element);
	  var elementName = isHtml
	    ? element.nodeName.toLowerCase()
	    : element.nodeName;
	  if (isHtml && isVoidElement(elementName) && element.childNodes.length === 0) {
	    return '';
	  } else {
	    return ("</" + elementName + ">");
	  }
	}

	function ensureSupportedSpecOptions(options) {
	  var unsupportedOptions = Object.keys(options).filter(
	    function (key) { return key !== 'attributes' &&
	      key !== 'name' &&
	      key !== 'children' &&
	      key !== 'onlyAttributes' &&
	      key !== 'textContent'; }
	  );

	  if (unsupportedOptions.length > 0) {
	    throw new Error(
	      ("Unsupported option" + (unsupportedOptions.length === 1 ? '' : 's') + ": " + (unsupportedOptions.join(', ')))
	    );
	  }
	}

	var lib = {
	  name: 'unexpected-dom',
	  installInto: function installInto(expect) {
	    expect = expect.child();
	    expect.use(magicPenPrism);

	    function bubbleError(body) {
	      return expect.withError(body, function (err) {
	        err.errorMode = 'bubble';
	        throw err;
	      });
	    }

	    expect.exportType({
	      name: 'DOMNode',
	      base: 'object',
	      identify: function identify(obj) {
	        return (
	          obj &&
	          obj.nodeName &&
	          [2, 3, 4, 5, 6, 7, 10, 11, 12].indexOf(obj.nodeType) > -1
	        );
	      },
	      equal: function equal(a, b) {
	        return a.nodeType === b.nodeType && a.nodeValue === b.nodeValue;
	      },
	      diff: function () {},
	      inspect: function inspect(element, depth, output) {
	        return output.code(
	          ((element.nodeName) + " \"" + (element.nodeValue) + "\""),
	          'prism-string'
	        );
	      },
	    });

	    expect.exportType({
	      name: 'DOMComment',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return obj && typeof obj.nodeType === 'number' && obj.nodeType === 8;
	      },
	      equal: function equal(a, b) {
	        return a.nodeValue === b.nodeValue;
	      },
	      inspect: function inspect(element, depth, output) {
	        return output.code(("<!--" + (element.nodeValue) + "-->"), 'html');
	      },
	      diff: function diff(actual, expected, output, diff$1, inspect, equal) {
	        var d = diff$1(
	          ("<!--" + (actual.nodeValue) + "-->"),
	          ("<!--" + (expected.nodeValue) + "-->")
	        );
	        d.inline = true;
	        return d;
	      },
	    });

	    // Recognize <!-- ignore --> as a special subtype of DOMComment so it can be targeted by assertions:
	    expect.exportType({
	      name: 'DOMIgnoreComment',
	      base: 'DOMComment',
	      identify: function identify(obj) {
	        return (
	          this.baseType.identify(obj) && /^\s*ignore\s*$/.test(obj.nodeValue)
	        );
	      },
	    });

	    expect.exportType({
	      name: 'DOMTextNode',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return obj && typeof obj.nodeType === 'number' && obj.nodeType === 3;
	      },
	      equal: function equal(a, b) {
	        return a.nodeValue === b.nodeValue;
	      },
	      inspect: function inspect(element, depth, output) {
	        return output.code(entitify(element.nodeValue.trim()), 'html');
	      },
	      diff: function diff(actual, expected, output, diff$1, inspect, equal) {
	        var d = diff$1(actual.nodeValue, expected.nodeValue);
	        d.inline = true;
	        return d;
	      },
	    });

	    expect.exportType({
	      name: 'DOMNodeList',
	      base: 'array-like',
	      prefix: function prefix(output) {
	        return output.text('NodeList[');
	      },
	      suffix: function suffix(output) {
	        return output.text(']');
	      },
	      similar: function similar(a, b) {
	        // Figure out whether a and b are "struturally similar" so they can be diffed inline.
	        return (
	          a.nodeType === 1 && b.nodeType === 1 && a.nodeName === b.nodeName
	        );
	      },
	      identify: function identify(obj) {
	        return (
	          obj &&
	          typeof obj.length === 'number' &&
	          typeof obj.toString === 'function' &&
	          typeof obj.item === 'function' &&
	          // With jsdom 6+, nodeList.toString() comes out as '[object Object]', so fall back to the constructor name:
	          (obj.toString().indexOf('NodeList') !== -1 ||
	            (obj.constructor && obj.constructor.name === 'NodeList'))
	        );
	      },
	    });

	    // Fake type to make it possible to build 'to satisfy' diffs to be rendered inline:
	    expect.exportType({
	      name: 'attachedDOMNodeList',
	      base: 'DOMNodeList',
	      indent: false,
	      prefix: function prefix(output) {
	        return output;
	      },
	      suffix: function suffix(output) {
	        return output;
	      },
	      delimiter: function delimiter(output) {
	        return output;
	      },
	      identify: function identify(obj) {
	        return obj && obj._isAttachedDOMNodeList;
	      },
	    });

	    function makeAttachedDOMNodeList(domNodeList, contentType) {
	      var attachedDOMNodeList = [];
	      for (var i = 0; i < domNodeList.length; i += 1) {
	        attachedDOMNodeList.push(domNodeList[i]);
	      }
	      attachedDOMNodeList._isAttachedDOMNodeList = true;
	      attachedDOMNodeList.ownerDocument = { contentType: contentType };
	      return attachedDOMNodeList;
	    }

	    expect.exportType({
	      name: 'HTMLDocType',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return (
	          obj &&
	          typeof obj.nodeType === 'number' &&
	          obj.nodeType === 10 &&
	          'publicId' in obj
	        );
	      },
	      inspect: function inspect(doctype, depth, output, inspect$1) {
	        return output.code(("<!DOCTYPE " + (doctype.name) + ">"), 'html');
	      },
	      equal: function equal(a, b) {
	        return a.toString() === b.toString();
	      },
	      diff: function diff(actual, expected, output, diff$1) {
	        var d = diff$1(
	          ("<!DOCTYPE " + (actual.name) + ">"),
	          ("<!DOCTYPE " + (expected.name) + ">")
	        );
	        d.inline = true;
	        return d;
	      },
	    });

	    expect.exportType({
	      name: 'DOMDocument',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return (
	          obj &&
	          typeof obj.nodeType === 'number' &&
	          obj.nodeType === 9 &&
	          obj.documentElement &&
	          obj.implementation
	        );
	      },
	      inspect: function inspect(document, depth, output, inspect$1) {
	        for (var i = 0; i < document.childNodes.length; i += 1) {
	          output.append(inspect$1(document.childNodes[i]));
	        }
	        return output;
	      },
	      equal: function equal(a, b, equal$1) {
	        return equal$1(a.childNodes, b.childNodes);
	      },
	      diff: function diff(actual, expected, output, diff$1, inspect, equal) {
	        output.inline = true;
	        output.append(
	          diff$1(
	            makeAttachedDOMNodeList(actual.childNodes),
	            makeAttachedDOMNodeList(expected.childNodes)
	          )
	        );
	        return output;
	      },
	    });

	    expect.exportType({
	      name: 'HTMLDocument',
	      base: 'DOMDocument',
	      identify: function identify(obj) {
	        return this.baseType.identify(obj) && isInsideHtmlDocument(obj);
	      },
	    });

	    expect.exportType({
	      name: 'XMLDocument',
	      base: 'DOMDocument',
	      identify: function identify(obj) {
	        return this.baseType.identify(obj) && !isInsideHtmlDocument(obj);
	      },
	      inspect: function inspect(document, depth, output, inspect$1) {
	        output.code('<?xml version="1.0"?>', 'xml');
	        for (var i = 0; i < document.childNodes.length; i += 1) {
	          output.append(inspect$1(document.childNodes[i], depth - 1));
	        }
	        return output;
	      },
	    });

	    expect.exportType({
	      name: 'DOMDocumentFragment',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return obj && obj.nodeType === 11; // In jsdom, documentFragment.toString() does not return [object DocumentFragment]
	      },
	      inspect: function inspect(documentFragment, depth, output, inspect$1) {
	        return output
	          .text('DocumentFragment[')
	          .append(inspect$1(documentFragment.childNodes, depth))
	          .text(']');
	      },
	      equal: function equal(a, b, equal$1) {
	        return equal$1(a.childNodes, b.childNodes);
	      },
	      diff: function diff(actual, expected, output, diff$1, inspect, equal) {
	        output.inline = true;
	        output.block(
	          diff$1(
	            makeAttachedDOMNodeList(actual.childNodes),
	            makeAttachedDOMNodeList(expected.childNodes)
	          )
	        );
	        return output;
	      },
	    });

	    expect.exportType({
	      name: 'DOMElement',
	      base: 'DOMNode',
	      identify: function identify(obj) {
	        return (
	          obj &&
	          typeof obj.nodeType === 'number' &&
	          obj.nodeType === 1 &&
	          obj.nodeName &&
	          obj.attributes
	        );
	      },
	      equal: function equal(a, b, equal$1) {
	        var aIsHtml = isInsideHtmlDocument(a);
	        var bIsHtml = isInsideHtmlDocument(b);
	        return (
	          aIsHtml === bIsHtml &&
	          (aIsHtml
	            ? a.nodeName.toLowerCase() === b.nodeName.toLowerCase()
	            : a.nodeName === b.nodeName) &&
	          equal$1(getAttributes(a), getAttributes(b)) &&
	          equal$1(a.childNodes, b.childNodes)
	        );
	      },
	      inspect: function inspect(element, depth, output, inspect$1) {
	        var elementName = element.nodeName.toLowerCase();
	        var startTag = stringifyStartTag(element);

	        output.code(startTag, 'html');
	        if (element.childNodes.length > 0) {
	          if (depth === 1) {
	            output.text('...');
	          } else {
	            var inspectedChildren = [];
	            if (elementName === 'script') {
	              var type = element.getAttribute('type');
	              if (!type || /javascript/.test(type)) {
	                type = 'javascript';
	              }
	              inspectedChildren.push(
	                output.clone().code(element.textContent, type)
	              );
	            } else if (elementName === 'style') {
	              inspectedChildren.push(
	                output
	                  .clone()
	                  .code(
	                    element.textContent,
	                    element.getAttribute('type') || 'text/css'
	                  )
	              );
	            } else {
	              for (var i = 0; i < element.childNodes.length; i += 1) {
	                inspectedChildren.push(inspect$1(element.childNodes[i]));
	              }
	            }

	            var width = startTag.length;
	            var sizes = inspectedChildren.map(function (inspectedChild) { return inspectedChild.size(); }
	            );

	            var multipleLines = sizes.some(function (size) {
	              width += size.width;
	              return width > 60 || size.height > 1;
	            });

	            if (multipleLines) {
	              output.nl().indentLines();

	              inspectedChildren.forEach(function (inspectedChild, index) {
	                var childSize = sizes[index];
	                if (childSize.width > 0 && childSize.height > 0) {
	                  output.i().block(inspectedChild);
	                }

	                output.nl();
	              });

	              output.outdentLines();
	            } else {
	              inspectedChildren.forEach(function (inspectedChild, index) { return output.append(inspectedChild); }
	              );
	            }
	          }
	        }
	        output.code(stringifyEndTag(element), 'html');
	        return output;
	      },
	      diffLimit: 512,
	      diff: function diff(actual, expected, output, diff$1, inspect, equal) {
	        var isHtml = isInsideHtmlDocument(actual);
	        output.inline = true;

	        if (Math.max(actual.length, expected.length) > this.diffLimit) {
	          output.jsComment(("Diff suppressed due to size > " + (this.diffLimit)));
	          return output;
	        }

	        var emptyElements =
	          actual.childNodes.length === 0 && expected.childNodes.length === 0;
	        var conflictingElement =
	          actual.nodeName.toLowerCase() !== expected.nodeName.toLowerCase() ||
	          !equal(getAttributes(actual), getAttributes(expected));

	        if (conflictingElement) {
	          var canContinueLine = true;
	          output.prismPunctuation('<').prismTag(actual.nodeName.toLowerCase());
	          if (
	            actual.nodeName.toLowerCase() !== expected.nodeName.toLowerCase()
	          ) {
	            output
	              .sp()
	              .annotationBlock(function (output) { return output
	                  .error('should be')
	                  .sp()
	                  .prismTag(expected.nodeName.toLowerCase()); }
	              )
	              .nl();
	            canContinueLine = false;
	          }
	          var actualAttributes = getAttributes(actual);
	          var expectedAttributes = getAttributes(expected);
	          Object.keys(actualAttributes).forEach(function (attributeName) {
	            output.sp(canContinueLine ? 1 : 2 + actual.nodeName.length);
	            writeAttributeToMagicPen(
	              output,
	              attributeName,
	              actualAttributes[attributeName],
	              isHtml
	            );
	            if (attributeName in expectedAttributes) {
	              if (
	                actualAttributes[attributeName] ===
	                expectedAttributes[attributeName]
	              ) {
	                canContinueLine = true;
	              } else {
	                output
	                  .sp()
	                  .annotationBlock(function (output) { return output
	                      .error('should equal')
	                      .sp()
	                      .append(
	                        inspect(entitify(expectedAttributes[attributeName]))
	                      ); }
	                  )
	                  .nl();
	                canContinueLine = false;
	              }
	              delete expectedAttributes[attributeName];
	            } else {
	              output
	                .sp()
	                .annotationBlock(function (output) { return output.error('should be removed'); })
	                .nl();
	              canContinueLine = false;
	            }
	          });
	          Object.keys(expectedAttributes).forEach(function (attributeName) {
	            output.sp(canContinueLine ? 1 : 2 + actual.nodeName.length);
	            output
	              .annotationBlock(function (output) {
	                output.error('missing').sp();
	                writeAttributeToMagicPen(
	                  output,
	                  attributeName,
	                  expectedAttributes[attributeName],
	                  isHtml
	                );
	              })
	              .nl();
	            canContinueLine = false;
	          });
	          output.prismPunctuation('>');
	        } else {
	          output.code(stringifyStartTag(actual), 'html');
	        }

	        if (!emptyElements) {
	          output
	            .nl()
	            .indentLines()
	            .i()
	            .block(
	              diff$1(
	                makeAttachedDOMNodeList(actual.childNodes),
	                makeAttachedDOMNodeList(expected.childNodes)
	              )
	            )
	            .nl()
	            .outdentLines();
	        }

	        output.code(stringifyEndTag(actual), 'html');
	        return output;
	      },
	    });

	    expect.exportAssertion(
	      '<DOMElement> to have (class|classes) <array|string>',
	      function (expect, subject, value) { return expect(subject, 'to have attributes', { class: value }); }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to only have (class|classes) <array|string>',
	      function (expect, subject, value) { return expect(subject, 'to have attributes', {
	          class: expect.it(function (className) {
	            var actualClasses = getClassNamesFromAttributeValue(className);
	            if (typeof value === 'string') {
	              value = getClassNamesFromAttributeValue(value);
	            }
	            return bubbleError(function () { return expect(actualClasses.sort(), 'to equal', value.sort()); }
	            );
	          }),
	        }); }
	    );

	    expect.exportAssertion(
	      '<DOMElement> not to have (class|classes) <array|string>',
	      function (expect, subject, value) {
	        return expect(subject, 'to have attributes', {
	          class: expect.it(function (className) {
	            var actualClasses = getClassNamesFromAttributeValue(className);
	            var expectedClasses;
	            if (typeof value === 'string') {
	              expectedClasses = getClassNamesFromAttributeValue(value);
	            } else {
	              expectedClasses = value;
	            }
	            return bubbleError(function () { return expect.apply(void 0, [ actualClasses, 'not to contain' ].concat( expectedClasses )); }
	            );
	          }),
	        });
	      }
	    );

	    expect.exportAssertion(
	      '<DOMTextNode> to [exhaustively] satisfy <DOMTextNode>',
	      function (expect, subject, value) { return expect(subject.nodeValue, 'to equal', value.nodeValue); }
	    );

	    expect.exportAssertion(
	      '<DOMComment> to [exhaustively] satisfy <DOMComment>',
	      function (expect, subject, value) { return expect(subject.nodeValue, 'to equal', value.nodeValue); }
	    );

	    // Avoid rendering a huge object diff when a text node is matched against a different node type:
	    expect.exportAssertion(
	      '<DOMTextNode> to [exhaustively] satisfy <object>',
	      function (expect, subject, value) { return expect.fail(); }
	    );

	    // Always passes:
	    expect.exportAssertion(
	      // Name each subject type to increase the specificity of the assertion
	      '<DOMComment|DOMElement|DOMTextNode|DOMDocument|HTMLDocType> to [exhaustively] satisfy <DOMIgnoreComment>',
	      function (expect, subject, value) {}
	    );

	    // Necessary because this case would otherwise be handled by the above catch-all for <object>:
	    expect.exportAssertion(
	      '<DOMTextNode> to [exhaustively] satisfy <regexp>',
	      function (expect, ref, value) {
	        var nodeValue = ref.nodeValue;

	        return expect(nodeValue, 'to satisfy', value);
	    }
	    );

	    expect.exportAssertion(
	      '<DOMTextNode> to [exhaustively] satisfy <any>',
	      function (expect, ref, value) {
	        var nodeValue = ref.nodeValue;

	        return expect(nodeValue, 'to satisfy', value);
	    }
	    );

	    function convertDOMNodeToSatisfySpec(node, isHtml) {
	      if (node.nodeType === 10) {
	        // HTMLDocType
	        return { name: node.nodeName };
	      } else if (node.nodeType === 1) {
	        // DOMElement
	        var name = isHtml ? node.nodeName.toLowerCase() : node.nodeName;

	        var result = { name: name };

	        if (node.attributes) {
	          result.attributes = {};
	          for (var i = 0; i < node.attributes.length; i += 1) {
	            result.attributes[node.attributes[i].name] =
	              isHtml && isBooleanAttribute(node.attributes[i].name)
	                ? true
	                : node.attributes[i].value || '';
	          }
	        }
	        result.children = Array.prototype.slice.call(node.childNodes);
	        return result;
	      } else if (node.nodeType === 3) {
	        // DOMTextNode
	        return node.nodeValue;
	      } else if (node.nodeType === 8) {
	        // DOMComment
	        return node;
	      } else {
	        throw new Error(
	          ("to satisfy: Node type " + (node.nodeType) + " is not yet supported in the value")
	        );
	      }
	    }

	    expect.exportAssertion(
	      '<DOMNodeList> to [exhaustively] satisfy <string>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);

	        expect.argsOutput = function (output) { return output.code(value, isHtml ? 'html' : 'xml'); };

	        return expect(
	          subject,
	          'to [exhaustively] satisfy',
	          (isHtml ? parseHtml(value, true) : parseXml(value)).childNodes
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMNodeList> to [exhaustively] satisfy <DOMNodeList>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);
	        var satisfySpecs = [];
	        for (var i = 0; i < value.length; i += 1) {
	          satisfySpecs.push(convertDOMNodeToSatisfySpec(value[i], isHtml));
	        }
	        return expect(subject, 'to [exhaustively] satisfy', satisfySpecs);
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocumentFragment> to [exhaustively] satisfy <string>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);

	        expect.argsOutput = function (output) { return output.code(value, isHtml ? 'html' : 'xml'); };

	        return expect(
	          subject,
	          'to [exhaustively] satisfy',
	          isHtml ? parseHtml(value, true) : parseXml(value)
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocumentFragment> to [exhaustively] satisfy <DOMDocumentFragment>',
	      function (expect, subject, ref) {
	        var childNodes = ref.childNodes;

	        var isHtml = isInsideHtmlDocument(subject);
	        return expect(
	          subject,
	          'to [exhaustively] satisfy',
	          Array.prototype.map.call(childNodes, function (childNode) { return convertDOMNodeToSatisfySpec(childNode, isHtml); }
	          )
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocumentFragment> to [exhaustively] satisfy <object|array>',
	      function (expect, ref, value) {
	          var childNodes = ref.childNodes;

	          return expect(childNodes, 'to [exhaustively] satisfy', value);
	    }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to [exhaustively] satisfy <string>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);
	        var documentFragment = isHtml
	          ? parseHtml(value, true)
	          : parseXml(value);
	        if (documentFragment.childNodes.length !== 1) {
	          throw new Error(
	            'HTMLElement to satisfy string: Only a single node is supported'
	          );
	        }

	        expect.argsOutput = function (output) { return output.code(value, isHtml ? 'html' : 'xml'); };

	        return expect(
	          subject,
	          'to [exhaustively] satisfy',
	          documentFragment.childNodes[0]
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument> to [exhaustively] satisfy <string>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);
	        var valueDocument = isHtml
	          ? parseHtml(value, false)
	          : parseXml(value);
	        return expect(
	          makeAttachedDOMNodeList(subject.childNodes),
	          'to [exhaustively] satisfy',
	          Array.prototype.map.call(valueDocument.childNodes, function (childNode) { return convertDOMNodeToSatisfySpec(childNode, isHtml); }
	          )
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument> to [exhaustively] satisfy <DOMDocument>',
	      function (expect, subject, ref) {
	        var childNodes = ref.childNodes;

	        var isHtml = isInsideHtmlDocument(subject);
	        return expect(
	          makeAttachedDOMNodeList(subject.childNodes),
	          'to [exhaustively] satisfy',
	          Array.prototype.map.call(childNodes, function (childNode) { return convertDOMNodeToSatisfySpec(childNode, isHtml); }
	          )
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to [exhaustively] satisfy <DOMElement>',
	      function (expect, subject, value) { return expect(
	          subject,
	          'to [exhaustively] satisfy',
	          convertDOMNodeToSatisfySpec(value, isInsideHtmlDocument(subject))
	        ); }
	    );

	    expect.exportAssertion(
	      [
	        '<DOMElement> to [exhaustively] satisfy <DOMDocumentFragment>',
	        '<DOMElement> to [exhaustively] satisfy <DOMTextNode>',
	        '<DOMTextNode> to [exhaustively] satisfy <DOMElement>',
	        '<DOMElement|DOMDocumentFragment|DOMDocument> to [exhaustively] satisfy <regexp>',
	        '<DOMDocumentFragment|DOMDocument> to [exhaustively] satisfy <DOMElement>' ],
	      function (expect, subject, value) { return expect.fail(); }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to [exhaustively] satisfy <object>',
	      function (expect, subject, value) {
	        var isHtml = isInsideHtmlDocument(subject);

	        if (expect.argTypes[0].is('expect.it')) {
	          expect.context.thisObject = subject;
	          return value(subject, expect.context);
	        }

	        ensureSupportedSpecOptions(value);
	        var promiseByKey = {
	          name: expect.promise(function () {
	            if (value && typeof value.name !== 'undefined') {
	              return bubbleError(function () { return expect(
	                  isHtml ? subject.nodeName.toLowerCase() : subject.nodeName,
	                  'to satisfy',
	                  value.name
	                ); }
	              );
	            }
	          }),
	          children: expect.promise(function () {
	            if (typeof value.children !== 'undefined') {
	              if (typeof value.textContent !== 'undefined') {
	                throw new Error(
	                  'The children and textContent properties are not supported together'
	                );
	              }

	              var contentType = subject.ownerDocument.contentType;
	              if (!contentType) {
	                // provide a value in the absence of a contentType (IE11)
	                contentType = isInsideHtmlDocument(subject)
	                  ? 'text/html'
	                  : 'application/xml';
	              }

	              return bubbleError(function () { return expect(
	                  makeAttachedDOMNodeList(subject.childNodes, contentType),
	                  'to satisfy',
	                  value.children
	                ); }
	              );
	            } else if (typeof value.textContent !== 'undefined') {
	              return bubbleError(function () { return expect(subject.textContent, 'to satisfy', value.textContent); }
	              );
	            }
	          }),
	          attributes: {},
	        };

	        var onlyAttributes =
	          (value && value.onlyAttributes) || expect.flags.exhaustively;
	        var attrs = getAttributes(subject);
	        var expectedAttributes = value && value.attributes;
	        var expectedAttributeNames = [];
	        var expectedValueByAttributeName = {};

	        if (typeof expectedAttributes !== 'undefined') {
	          if (typeof expectedAttributes === 'string') {
	            expectedAttributes = [expectedAttributes];
	          }
	          if (Array.isArray(expectedAttributes)) {
	            expectedAttributes.forEach(function (attributeName) {
	              expectedValueByAttributeName[attributeName] = true;
	            });
	          } else if (
	            expectedAttributes &&
	            typeof expectedAttributes === 'object'
	          ) {
	            expectedValueByAttributeName = expectedAttributes;
	          }
	          Object.keys(expectedValueByAttributeName).forEach(function (attributeName) {
	            expectedAttributeNames.push(attributeName);
	          });

	          expectedAttributeNames.forEach(function (attributeName) {
	            var attributeValue = subject.getAttribute(attributeName);
	            var expectedAttributeValue =
	              expectedValueByAttributeName[attributeName];
	            promiseByKey.attributes[attributeName] = expect.promise(function () {
	              if (typeof expectedAttributeValue === 'undefined') {
	                return bubbleError(function () { return expect(subject.hasAttribute(attributeName), 'to be false'); }
	                );
	              } else if (isEnumeratedAttribute(attributeName)) {
	                var indexOfEnumeratedAttributeValue = enumeratedAttributeValues[
	                  attributeName
	                ].indexOf(expectedAttributeValue);

	                return bubbleError(function () {
	                  if (indexOfEnumeratedAttributeValue === -1) {
	                    expect.fail(function (output) { return output
	                        .text('Invalid expected value ')
	                        .appendInspected(expectedAttributeValue)
	                        .text('. Supported values include: ')
	                        .appendItems(
	                          enumeratedAttributeValues[attributeName],
	                          ', '
	                        ); }
	                    );
	                  }

	                  expect(attributeValue, 'to satisfy', expectedAttributeValue);
	                });
	              } else if (expectedAttributeValue === true) {
	                return bubbleError(function () { return expect(subject.hasAttribute(attributeName), 'to be true'); }
	                );
	              } else if (
	                attributeName === 'class' &&
	                (typeof expectedAttributeValue === 'string' ||
	                  Array.isArray(expectedAttributeValue))
	              ) {
	                var actualClasses = getClassNamesFromAttributeValue(
	                  attributeValue
	                );
	                var expectedClasses = expectedAttributeValue;
	                if (typeof expectedClasses === 'string') {
	                  expectedClasses = getClassNamesFromAttributeValue(
	                    expectedAttributeValue
	                  );
	                }
	                if (onlyAttributes) {
	                  return bubbleError(function () { return expect(
	                      actualClasses.sort(),
	                      'to equal',
	                      expectedClasses.sort()
	                    ); }
	                  );
	                } else {
	                  if (expectedClasses.length === 0) {
	                    return bubbleError(function () { return expect(expectedClasses, 'to be empty'); }
	                    );
	                  }
	                  return bubbleError(function () { return expect.apply(void 0, [ actualClasses, 'to contain' ].concat( expectedClasses )); }
	                  );
	                }
	              } else if (attributeName === 'style') {
	                var expectedStyleObj;
	                if (typeof expectedValueByAttributeName.style === 'string') {
	                  validateStyles(expect, expectedValueByAttributeName.style);
	                  expectedStyleObj = styleStringToObject(
	                    expectedValueByAttributeName.style
	                  );
	                } else {
	                  expectedStyleObj = expectedValueByAttributeName.style;
	                }

	                if (onlyAttributes) {
	                  return bubbleError(function () { return expect(
	                      attrs.style,
	                      'to exhaustively satisfy',
	                      expectedStyleObj
	                    ); }
	                  );
	                } else {
	                  return bubbleError(function () { return expect(attrs.style, 'to satisfy', expectedStyleObj); }
	                  );
	                }
	              } else if (
	                expect.findTypeOf(expectedAttributeValue).is('expect.it')
	              ) {
	                expect.context.thisObject = subject;
	                return bubbleError(function () { return expectedAttributeValue(attributeValue, expect.context); }
	                );
	              } else {
	                return bubbleError(function () { return expect(attributeValue, 'to satisfy', expectedAttributeValue); }
	                );
	              }
	            });
	          });

	          promiseByKey.attributePresence = expect.promise(function () {
	            var attributeNamesExpectedToBeDefined = [];
	            expectedAttributeNames.forEach(function (attributeName) {
	              if (
	                typeof expectedValueByAttributeName[attributeName] ===
	                'undefined'
	              ) {
	                expect(attrs, 'not to have key', attributeName);
	              } else {
	                attributeNamesExpectedToBeDefined.push(attributeName);
	                expect(attrs, 'to have key', attributeName);
	              }
	            });
	            if (onlyAttributes) {
	              expect(
	                Object.keys(attrs).sort(),
	                'to equal',
	                attributeNamesExpectedToBeDefined.sort()
	              );
	            }
	          });
	        }

	        return expect.promise.all(promiseByKey).caught(function () { return expect.promise.settle(promiseByKey).then(function () {
	            expect.fail({
	              diff: function diff(output, diff$1, inspect, equal) {
	                output.block(function (output) {
	                  var seenError = false;
	                  output
	                    .prismPunctuation('<')
	                    .prismTag(
	                      isHtml ? subject.nodeName.toLowerCase() : subject.nodeName
	                    );
	                  if (promiseByKey.name.isRejected()) {
	                    seenError = true;
	                    var nameError = promiseByKey.name.reason();
	                    output.sp().annotationBlock(function (output) { return output
	                        .error(
	                          (nameError && nameError.getLabel()) ||
	                            'should satisfy'
	                        )
	                        .sp()
	                        .append(inspect(value.name)); }
	                    );
	                  }
	                  var inspectedAttributes = [];
	                  Object.keys(attrs).forEach(function (attributeName) {
	                    var attributeOutput = output.clone();
	                    var promise = promiseByKey.attributes[attributeName];
	                    writeAttributeToMagicPen(
	                      attributeOutput,
	                      attributeName,
	                      attrs[attributeName],
	                      isHtml
	                    );
	                    if (
	                      (promise && promise.isFulfilled()) ||
	                      (!promise &&
	                        (!onlyAttributes ||
	                          expectedAttributeNames.indexOf(attributeName) !== -1))
	                    ) ; else {
	                      seenError = true;
	                      attributeOutput.sp().annotationBlock(function (output) {
	                        if (
	                          promise &&
	                          typeof expectedValueByAttributeName[attributeName] !==
	                            'undefined'
	                        ) {
	                          output.appendErrorMessage(promise.reason());
	                        } else {
	                          // onlyAttributes === true
	                          output.error('should be removed');
	                        }
	                      });
	                    }
	                    inspectedAttributes.push(attributeOutput);
	                  });
	                  expectedAttributeNames.forEach(function (attributeName) {
	                    if (!subject.hasAttribute(attributeName)) {
	                      var promise = promiseByKey.attributes[attributeName];
	                      if (!promise || promise.isRejected()) {
	                        seenError = true;
	                        var err = promise && promise.reason();
	                        var attributeOutput = output
	                          .clone()
	                          .annotationBlock(function (output) {
	                            output
	                              .error('missing')
	                              .sp()
	                              .prismAttrName(attributeName, 'html');
	                            if (
	                              expectedValueByAttributeName[attributeName] !==
	                              true
	                            ) {
	                              output
	                                .sp()
	                                .error(
	                                  (err && err.getLabel()) || 'should satisfy'
	                                )
	                                .sp()
	                                .append(
	                                  inspect(
	                                    expectedValueByAttributeName[attributeName]
	                                  )
	                                );
	                            }
	                          });
	                        inspectedAttributes.push(attributeOutput);
	                      }
	                    }
	                  });
	                  if (inspectedAttributes.length > 0) {
	                    if (seenError) {
	                      output
	                        .nl()
	                        .indentLines()
	                        .indent()
	                        .block(function (output) {
	                          inspectedAttributes.forEach(function (item, i) {
	                            if (i > 0) {
	                              output.nl();
	                            }
	                            output.append(item);
	                          });
	                        })
	                        .outdentLines()
	                        .nl();
	                    } else {
	                      output.sp();
	                      inspectedAttributes.forEach(function (item, i) {
	                        if (i > 0) {
	                          output.sp();
	                        }
	                        output.append(item);
	                      });
	                    }
	                  } else if (seenError) {
	                    // The tag name mismatched
	                    output.nl();
	                  }

	                  output.prismPunctuation('>');
	                  var childrenError =
	                    promiseByKey.children.isRejected() &&
	                    promiseByKey.children.reason();
	                  if (childrenError) {
	                    var childrenDiff = childrenError.getDiff(output);
	                    if (childrenDiff && childrenDiff.inline) {
	                      output
	                        .nl()
	                        .indentLines()
	                        .i()
	                        .block(childrenDiff)
	                        .nl()
	                        .outdentLines();
	                    } else {
	                      output
	                        .nl()
	                        .indentLines()
	                        .i()
	                        .block(function (output) {
	                          for (
	                            var i = 0;
	                            i < subject.childNodes.length;
	                            i += 1
	                          ) {
	                            output.append(inspect(subject.childNodes[i])).nl();
	                          }
	                        });
	                      output
	                        .sp()
	                        .annotationBlock(function (output) { return output.appendErrorMessage(childrenError); }
	                        );
	                      output.nl();
	                    }
	                  } else {
	                    for (var i = 0; i < subject.childNodes.length; i += 1) {
	                      output.append(inspect(subject.childNodes[i]));
	                    }
	                  }
	                  output.code(stringifyEndTag(subject), 'html');
	                });
	                output.inline = true;
	                return output;
	              },
	            });
	          }); }
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to [only] have (attribute|attributes) <string+>',
	      function (expect, subject) {
	          var args = [], len = arguments.length - 2;
	          while ( len-- > 0 ) args[ len ] = arguments[ len + 2 ];

	          return expect(subject, 'to [only] have attributes', args);
	    }
	    );

	    expect.exportAssertion(
	      '<DOMElement> not to have (attribute|attributes) <array>',
	      function (expect, subject, value) {
	        var attributes = getAttributes(subject);

	        value.forEach(function (name) {
	          delete attributes[name];
	        });

	        return expect(subject, 'to only have attributes', attributes);
	      }
	    );

	    expect.exportAssertion(
	      '<DOMElement> not to have (attribute|attributes) <string+>',
	      function (expect, subject) {
	          var args = [], len = arguments.length - 2;
	          while ( len-- > 0 ) args[ len ] = arguments[ len + 2 ];

	          return expect(subject, 'not to have attributes', args);
	    }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to [only] have (attribute|attributes) <array|object>',
	      function (expect, subject, value) { return expect(subject, 'to satisfy', {
	          attributes: value,
	          onlyAttributes: expect.flags.only,
	        }); }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to have [no] (child|children)',
	      function (expect, ref) {
	          var childNodes = ref.childNodes;

	          return expect.flags.no
	          ? expect(childNodes, 'to be empty')
	          : expect(childNodes, 'not to be empty');
	    }
	    );

	    expect.exportAssertion(
	      '<DOMElement> to have text <any>',
	      function (expect, ref, value) {
	          var textContent = ref.textContent;

	          return expect(textContent, 'to satisfy', value);
	    }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment> [when] queried for [first] <string> <assertion?>',
	      function (expect, subject, query) {
	        var queryResult;

	        expect.argsOutput[0] = function (output) { return output.green(query); };
	        expect.errorMode = 'nested';

	        if (expect.flags.first) {
	          queryResult = subject.querySelector(query);
	          if (!queryResult) {
	            expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	            expect.fail(function (output) { return output
	                .error('The selector')
	                .sp()
	                .jsString(query)
	                .sp()
	                .error('yielded no results'); }
	            );
	          }
	        } else {
	          queryResult = subject.querySelectorAll(query);
	          if (queryResult.length === 0) {
	            expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	            expect.fail(function (output) { return output
	                .error('The selector')
	                .sp()
	                .jsString(query)
	                .sp()
	                .error('yielded no results'); }
	            );
	          }
	        }
	        return expect.shift(queryResult);
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment> [when] queried for test id <string> <assertion?>',
	      function (expect, subject, testId) {
	        expect.errorMode = 'nested';

	        var escapedTestId = JSON.stringify(testId);

	        return expect(
	          subject,
	          'queried for first',
	          ("[data-test-id=" + escapedTestId + "]")
	        ).then(function (queryResult) { return expect.shift(queryResult); });
	      }
	    );

	    expect.exportAssertion(
	      [
	        '<DOMDocument|DOMElement|DOMDocumentFragment> to contain [no] elements matching <string>',
	        '<DOMDocument|DOMElement|DOMDocumentFragment> [not] to contain elements matching <string>' ],
	      function (expect, subject, query) {
	        if (expect.flags.no || expect.flags.not) {
	          return expect(subject.querySelectorAll(query), 'to satisfy', []);
	        }

	        expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	        return expect(subject.querySelectorAll(query), 'not to satisfy', []);
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment> [not] to contain test id <string>',
	      function (expect, subject, testId) {
	        expect.errorMode = 'nested';

	        var escapedTestId = JSON.stringify(testId);

	        return expect(
	          subject,
	          '[not] to contain elements matching',
	          ("[data-test-id=" + escapedTestId + "]")
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment> [not] to match <string>',
	      function (expect, subject, query) {
	        expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	        return expect(matchesSelector(subject, query), '[not] to be true');
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment> [not] to have test id <string>',
	      function (expect, subject, testId) {
	        expect.errorMode = 'nested';
	        expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	        var escapedTestId = JSON.stringify(testId);

	        return expect(
	          subject,
	          '[not] to match',
	          ("[data-test-id=" + escapedTestId + "]")
	        );
	      }
	    );

	    expect.exportAssertion(
	      '<string> [when] parsed as (html|HTML) [fragment] <assertion?>',
	      function (expect, subject) {
	        expect.errorMode = 'nested';
	        return expect.shift(parseHtml(subject, expect.flags.fragment));
	      }
	    );

	    expect.exportAssertion(
	      '<string> [when] parsed as (xml|XML) <assertion?>',
	      function (expect, subject) {
	        expect.errorMode = 'nested';
	        return expect.shift(parseXml(subject));
	      }
	    );

	    function memoize(fn) {
	      var map = new Map();
	      return function (node) {
	        var spec = map.get(node);
	        if (typeof spec === 'undefined') {
	          spec = fn(node);
	          map.set(node, spec);
	        }
	        return spec;
	      };
	    }

	    function scoreElementAgainstSpec(
	      element,
	      spec,
	      memoizedConvertDOMNodeToSatisfySpec
	    ) {
	      var isTextSimilar = function (value, valueSpec) {
	        var actual = (value || '').trim().toLowerCase();
	        if (typeof valueSpec === 'string') {
	          if (actual === valueSpec.trim().toLowerCase()) {
	            return true;
	          }
	        } else if (valueSpec instanceof RegExp) {
	          if (valueSpec.test(actual)) {
	            return true;
	          }
	        } else if (typeof valueSpec === 'function') {
	          return true;
	        }

	        return false;
	      };

	      var isHtml = isInsideHtmlDocument(element);

	      var score = 0;

	      var nodeName = isHtml
	        ? element.nodeName.toLowerCase()
	        : element.nodeName;

	      if (isTextSimilar(nodeName, spec.name)) {
	        score++;
	      }

	      if (isTextSimilar(element.textContent, spec.textContent)) {
	        score++;
	      }

	      if (typeof element.hasAttribute === 'function') {
	        var attributes = spec.attributes || {};
	        var className = attributes.class;
	        var style = attributes.style;

	        if (className && element.hasAttribute('class')) {
	          if (typeof className === 'string') {
	            var expectedClasses = getClassNamesFromAttributeValue(className);
	            var actualClasses = getClassNamesFromAttributeValue(
	              element.getAttribute('class')
	            );

	            expectedClasses.forEach(function (expectedClass) {
	              if (actualClasses.indexOf(expectedClass) !== -1) {
	                score++;
	              }
	            });
	          } else if (isTextSimilar(element.getAttribute('class'), className)) {
	            score++;
	          }
	        }

	        if (style && element.hasAttribute('style')) {
	          var expectedStyles =
	            typeof style === 'string' ? styleStringToObject(style) : style;
	          var actualStyles = styleStringToObject(
	            element.getAttribute('style')
	          );

	          Object.keys(expectedStyles).forEach(function (styleName) {
	            var expectedStyle = expectedStyles[styleName];
	            var actualStyle = actualStyles[styleName];

	            if (actualStyle) {
	              score++;
	            }

	            if (isTextSimilar(actualStyle, expectedStyle)) {
	              score++;
	            }
	          });
	        }

	        var specialAttributes = ['style', 'class'];
	        var ids = ['id', 'data-test-id', 'data-testid'];

	        Object.keys(attributes).forEach(function (attributeName) {
	          if (specialAttributes.indexOf(attributeName) !== -1) {
	            return; // skip
	          }

	          if (element.hasAttribute(attributeName)) {
	            if (typeof attributes[attributeName] === 'boolean') {
	              score++;
	            }

	            if (
	              element.getAttribute(attributeName) === attributes[attributeName]
	            ) {
	              score += ids.indexOf(attributeName) === -1 ? 1 : 100;
	            }
	          } else if (typeof attributes[attributeName] === 'undefined') {
	            score++;
	          }
	        });
	      }

	      var expectedChildren = spec.children || [];

	      expectedChildren.forEach(function (childSpec, i) {
	        var child = element.childNodes[i];
	        var childType = expect.findTypeOf(child);
	        if (expect.findTypeOf(childSpec).is('DOMNode')) {
	          childSpec = memoizedConvertDOMNodeToSatisfySpec(childSpec);
	        }

	        if (!child) {
	          return;
	        }

	        if (typeof childSpec.nodeType === 'number') {
	          if (child.nodeType === childSpec.nodeType) {
	            if (childType.is('DOMElement')) {
	              // Element
	              score += scoreElementAgainstSpec(
	                element.childNodes[i],
	                memoizedConvertDOMNodeToSatisfySpec(childSpec),
	                memoizedConvertDOMNodeToSatisfySpec
	              );
	            }

	            score++;
	          } else if (expect.findTypeOf(childSpec).is('DOMIgnoreComment')) {
	            score++;
	          }
	        } else if (
	          childType.is('DOMElement') &&
	          typeof childSpec === 'object'
	        ) {
	          score += scoreElementAgainstSpec(
	            element.childNodes[i],
	            childSpec,
	            memoizedConvertDOMNodeToSatisfySpec
	          );
	        } else if (
	          childType.is('DOMTextNode') &&
	          isTextSimilar(child.nodeValue, childSpec)
	        ) {
	          score++;
	        }
	      });

	      return score;
	    }

	    function findMatchesWithGoodScore(
	      data,
	      spec,
	      memoizedConvertDOMNodeToSatisfySpec
	    ) {
	      memoizedConvertDOMNodeToSatisfySpec =
	        memoizedConvertDOMNodeToSatisfySpec ||
	        memoize(convertDOMNodeToSatisfySpec);
	      var elements =
	        typeof data.length === 'number'
	          ? Array.prototype.slice.call(data)
	          : [data];

	      var result = [];
	      var bestScore = 0;

	      elements.forEach(function (element) {
	        var score = scoreElementAgainstSpec(
	          element,
	          spec,
	          memoizedConvertDOMNodeToSatisfySpec
	        );
	        bestScore = Math.max(score, bestScore);

	        if (score > 0 && score >= bestScore) {
	          result.push({ score: score, element: element });
	        }

	        for (var i = 0; i < element.childNodes.length; i += 1) {
	          var child = element.childNodes[i];
	          if (child.nodeType === 1) {
	            result.push.apply(
	              result, findMatchesWithGoodScore(
	                child,
	                spec,
	                memoizedConvertDOMNodeToSatisfySpec
	              )
	            );
	          }
	        }
	      });

	      result.sort(function (a, b) { return b.score - a.score; });

	      if (result.length > 0) {
	        var bestScore$1 = result[0].score;

	        return result.filter(function (ref) {
	          var score = ref.score;

	          return score === bestScore$1;
	        });
	      }

	      return result;
	    }

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement|DOMDocumentFragment|DOMNodeList> [not] to contain <DOMElement|object|string>',
	      function (expect, subject, value) {
	        var nodes = subject.childNodes || makeAttachedDOMNodeList(subject);
	        var isHtml = isInsideHtmlDocument(
	          subject.childNodes ? subject : nodes
	        );
	        var valueType = expect.findTypeOf(value);
	        var spec = value;

	        if (valueType.is('expect.it')) {
	          throw new Error(
	            'Unsupported value for "to contain" assertion: expect.it'
	          );
	        } else if (valueType.is('DOMElement')) {
	          spec = convertDOMNodeToSatisfySpec(value, isHtml);
	        } else if (valueType.is('string')) {
	          var documentFragment = isHtml
	            ? parseHtml(value, true)
	            : parseXml(value);

	          if (documentFragment.childNodes.length !== 1) {
	            throw new Error(
	              'HTMLElement to contain string: Only a single node is supported'
	            );
	          }

	          spec = convertDOMNodeToSatisfySpec(
	            documentFragment.childNodes[0],
	            isHtml
	          );

	          if (typeof spec === 'string') {
	            throw new Error(
	              'HTMLElement to contain string: please provide a HTML structure as a string'
	            );
	          }

	          expect.argsOutput = function (output) { return output.appendInspected(documentFragment.childNodes[0]); };

	          ensureSupportedSpecOptions(spec);
	        }

	        var scoredElements = findMatchesWithGoodScore(nodes, spec);

	        if (expect.flags.not) {
	          if (scoredElements.length > 0) {
	            return expect.withError(
	              function () { return expect(
	                  scoredElements.map(function (ref) {
	                    var element = ref.element;

	                    return element;
	                  }),
	                  'not to have an item satisfying',
	                  spec
	                ); },
	              function () {
	                var bestMatch = scoredElements[0].element;

	                expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };

	                expect.fail({
	                  diff: function (output, diff, inspect, equal) {
	                    return output
	                      .error('Found:')
	                      .nl(2)
	                      .appendInspected(bestMatch);
	                  },
	                });
	              }
	            );
	          }
	        } else {
	          if (scoredElements.length === 0) {
	            expect.subjectOutput = function (output) { return expect.inspect(subject, Infinity, output); };
	            expect.fail();
	          }

	          return expect.withError(
	            function () { return expect(
	                scoredElements.map(function (ref) {
	                  var element = ref.element;

	                  return element;
	                }),
	                'to have an item satisfying',
	                spec
	              ); },
	            function () {
	              var bestMatch = scoredElements[0].element;

	              return expect(bestMatch, 'to satisfy', spec);
	            }
	          );
	        }
	      }
	    );

	    expect.exportAssertion(
	      '<DOMElement> [not] to have focus',
	      function (expect, subject) {
	        var hasFocus = false;
	        try {
	          hasFocus = subject === subject.ownerDocument.activeElement;
	        } catch (err) {}
	        expect(hasFocus, '[not] to be true');
	      }
	    );

	    expect.exportAssertion(
	      '<DOMDocument|DOMElement> to contain focused element matching <string>',
	      function (expect, subject, selector) {
	        expect(subject, 'to contain elements matching', selector);
	        expect.errorMode = 'nested';
	        expect(subject.querySelector(selector), 'to have focus');
	      }
	    );
	  },
	};
	var lib_1 = lib.name;
	var lib_2 = lib.installInto;

	exports.default = lib;
	exports.installInto = lib_2;
	exports.name = lib_1;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
